#!/usr/bin/perl

#  Test case exerciser for exhmcg.  
#  Copyright (C) 2003  Hkan Johansson
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
	
mkdir ("work");

testasm("main_func1_arg_plus_1.asm");
testasm("main_func1_use_stack.asm");
testasm("main_func1_use_stack2.asm");
testasm("partial.asm");
# testasm("jmpset.asm");
testasm("func1.asm");

sub testasm($) {
    my $name = shift;
    
    my $basename = $name;
    $basename =~ s/\..*//;
    
    print "Testing: $name , $basename\n";
    
    # do all testing in an directory for that
    
    my $dir = "work/$basename/";
    
    mkdir ($dir);
    
    # first compile it

    runcmd(("nasm -f elf -o $dir$basename.o $name"));
    runcmd(("ld -s -o $dir$basename $dir$basename.o"));

    # now try to run it, and capture all stdout, stderr and return code

    my $origout = testrun("$dir$basename","${dir}orig");

    # run it through the tuner

    runcmd("../exmhcg/exmhcg $dir$basename");

    runcmd("mv processed.exe $dir$basename.new");

    # now try to run it again, and capture all stdout, stderr and return code

    my $origout = testrun("$dir$basename.new","${dir}new");

    # run it through the tuner again to get disassembler

    runcmd("../exmhcg/exmhcg $dir$basename.new");
}

sub runcmd(@) {
    my $cmd = shift;

    # print "Running: $cmd > lastoutput 2> lasterrors\n";

    system(("$cmd >lastoutput 2>lasterrors")) == 0 
	or die "system $cmd failed: $?";
}

sub testrun($)
{
    my $cmdname = shift;
    my $prefix = shift;

    # print "Testrun: $cmdname\n";

    my $retval = system("$cmdname >${prefix}output 2>${prefix}errors");
    
    my $output = readfile ("${prefix}output");
    my $errors = readfile ("${prefix}errors");

    my $exit_value = $retval >> 8;

    print "Return value: $retval => $exit_value\n";

    return ($retval,$output,$errors);
}

sub readfile($)
{
    my $name = shift;
    my $data = ();

    open(INFILE,'<',$name) or die "Could not open $name for read: $?";

    while (<INFILE>)
    {
	$data .= $_;
    }   

    close INFILE;    
}
