/*  createhtml - library to generate html files
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// Common.h: interface for the codeTrace class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__COMMON_H__INCLUDED_)
#define __COMMON_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <assert.h>

#ifndef NULL
#define NULL    0          
#endif

typedef unsigned int	uint;

typedef unsigned char	byte;  // 1 bytes
typedef unsigned short	word;  // 2 bytes
typedef unsigned int	dword; // 4 bytes

#ifndef FOR_EACH_EXTRA_ARGS
#define FOR_EACH_EXTRA_ARGS

template<class __II, class __Fn, class __An1, class __An2> inline
        __Fn for_each(__II __F, __II __L, __Fn __Op, __An1 __arg1, __An2 __arg2)
        {for (; __F != __L; ++__F)
                __Op(*__F,__arg1,__arg2);
        return (__Op); }

template<class __II, class __Fn, class __An1> inline
        __Fn for_each(__II __F, __II __L, __Fn __Op, __An1 __arg1)
        { for (; __F != __L; ++__F)
                __Op(*__F,__arg1);
                return (__Op); }

#endif // !defined(FOR_EACH_EXTRA_ARGS)

#ifdef WIN32
#pragma warning( disable : 4786 4788 )  // because of bad vc++ (gcc does better...)
#endif

#endif // !defined(__GLOBALDEFS_H__INCLUDED_)



