/*  createhtml - library to generate html files
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// HtmlAttribute.cpp: implementation of the HtmlAttribute class.
//
//////////////////////////////////////////////////////////////////////

#include "HtmlAttribute.h" // dep_chk_needed 

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

HtmlAttribute::HtmlAttribute()
{

}

HtmlAttribute::~HtmlAttribute()
{

}

void HtmlAttribute::Render (ostream* pOut,HtmlPage* /* pPage */)
{
	(*pOut) << ' ' << GetName ();
}

//////////////////////////////////////////////////////////////////////

#include "HtmlAttributes.h" // dep_chk_unknown 

#include "UrlFile.h" // dep_chk_needed 
#include "HtmlPage.h" // dep_chk_needed 

void HtmlAttrib__UrlItemPtr::Render (ostream* pOut,HtmlPage* pPage)
{
	UrlFile* pPageFile = pPage->GetFile ();
	
	assert (pPageFile); // or we won't be able to work out relative path
	assert (m_value);

	(*pOut) << ' ' << GetName () << '=';

	// so the html page being generated is reflected by pPageFile
	// and we are UrlItem* m_value
	// now, we'll try to find a common parent

	(*pOut) << pPageFile->GetRelativePathToItem(m_value);
}

void HtmlAttrib__UrlItemPtr_String::Render (ostream* pOut,HtmlPage* pPage)
{
	UrlFile* pPageFile = pPage->GetFile ();
	
	assert (pPageFile); // or we won't be able to work out relative path
	assert (m_value);

	(*pOut) << ' ' << GetName () << '=';

	// so the html page being generated is reflected by pPageFile
	// and we are UrlItem* m_value
	// now, we'll try to find a common parent

	(*pOut) << pPageFile->GetRelativePathToItem(m_value);
	(*pOut) << m_value2;
}



