/*  createhtml - library to generate html files
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// HtmlAttribute.h: interface for the HtmlAttribute class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__HTML_ATTRIBUTE_H__INCLUDED_)
#define __HTML_ATTRIBUTE_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <ostream>

#include <assert.h>
#include <string>

using namespace std;

class HtmlPage;

class HtmlAttribute  
{
public:
	HtmlAttribute();
	virtual ~HtmlAttribute();

public:
	virtual void Render (ostream* pOut,HtmlPage* pPage);

public:
	virtual const char* GetName () = 0;
};

using namespace std;

class HtmlAttribGeneric : public HtmlAttribute
{
public:
	HtmlAttribGeneric(const string& strName,const string& strValue) { m_strName = strName; m_strValue = strValue; } 
	virtual ~HtmlAttribGeneric() { } 
protected: 
	string m_strName;
	string m_strValue;

public:
	virtual void Render (ostream* pOut,HtmlPage* /* pPage */) { (*pOut) << ' ' << m_strName << '=' << m_strValue; }

public:
	virtual const char* GetName () { assert (false); return 0; };
};

#endif // !defined(__HTML_ATTRIBUTE_H__INCLUDED_)
