/*  createhtml - library to generate html files
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// HtmlBinaryTag.cpp: implementation of the HtmlBinaryTag class.
//
//////////////////////////////////////////////////////////////////////

#include "Common.h"
#include "HtmlBinaryTag.h" // dep_chk_needed 
#include "HtmlSimpleText.h" // dep_chk_needed 

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

HtmlBinaryTag::HtmlBinaryTag()
{

}

HtmlBinaryTag::HtmlBinaryTag(const string& strText)
{
  AddObject(new HtmlSimpleText(strText));
}

HtmlBinaryTag::HtmlBinaryTag(const char* pText)
{
  AddObject(new HtmlSimpleText(pText));
}

HtmlBinaryTag::~HtmlBinaryTag()
{

}

inline void RenderAndDeleteHtmlObject (HtmlObject* pObject,ostream* pOut,HtmlPage* pPage)
{
  assert (pObject);
  pObject->Render (pOut,pPage);
  delete pObject;
}

void HtmlBinaryTag::RenderContents (ostream* pOut,HtmlPage* pPage)
{
  for_each (m_vectObjects.begin(),m_vectObjects.end(),RenderAndDeleteHtmlObject,pOut,pPage);
  m_vectObjects.clear();
}

void HtmlBinaryTag::RenderEndTag (ostream* pOut)
{
  (*pOut) << "</" << GetName () << '>';
}

void HtmlBinaryTag::Render (ostream* pOut,HtmlPage* pPage)
{
  HtmlTag::Render(pOut,pPage);
  RenderContents(pOut,pPage);
  RenderEndTag(pOut);
}

