/*  createhtml - library to generate html files
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// HtmlBinaryTag.h: interface for the HtmlBinaryTag class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__HTML_BINARY_TAG_H__INCLUDED_)
#define __HTML_BINARY_TAG_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "HtmlTag.h" // dep_chk_needed 

class HtmlBinaryTag;

class HtmlBinaryTagPtr 
{ 
 public:
  HtmlBinaryTagPtr() { }
  HtmlBinaryTagPtr(HtmlBinaryTag* src) { ptr = src; }
  HtmlBinaryTagPtr(const HtmlBinaryTagPtr& src) { ptr = src.ptr; }
  ~HtmlBinaryTagPtr() { }

 public:
  HtmlBinaryTagPtr& operator=(const HtmlBinaryTagPtr& src) { ptr = src.ptr; return *this; }

  HtmlBinaryTag* ptr;


};

class HtmlBinaryTag : public HtmlTag  
{
public:
	HtmlBinaryTag();
	HtmlBinaryTag(const string& strText);
	HtmlBinaryTag(const char* pText);
	virtual ~HtmlBinaryTag();

	operator HtmlBinaryTagPtr() { return HtmlBinaryTagPtr(this); }

public:
	virtual void Render (ostream* pOut,HtmlPage* pPage);

	void RenderContents (ostream* pOut,HtmlPage* pPage);
	void RenderEndTag (ostream* pOut);
};
/*
HtmlBinaryTag& operator<<(HtmlBinaryTag& tag1,const string& strText);
HtmlBinaryTag& operator<<(HtmlBinaryTag& tag1,const char* pText);
*/
#endif // !defined(__HTML_BINARY_TAG_H__INCLUDED_)
