/*  createhtml - library to generate html files
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// UrlFile.cpp: implementation of the UrlFile class.
//
//////////////////////////////////////////////////////////////////////

#include "UrlFile.h" // dep_chk_needed 
// #include "UrlFolder.h" // dep_chk_unknown 

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

UrlFile::UrlFile(const string& strName)
	: UrlItem(strName)
{

}

UrlFile::~UrlFile()
{

}

ofstream* UrlFile::GetOutStream ()
{
  m_pParent->CreateDir();
  
  ofstream* pOutStream = new ofstream(GetPath ().c_str(),ios::out | ios::binary);
  
  //	pOutStream->setmode(filebuf::binary);

  // printf ("Opened: %s\n",GetPath ().c_str());

  if (!pOutStream->is_open())
    {
      printf ("Failed to open output file: %s\n",GetPath ().c_str());
      exit(1); /// hmmm, do something about this horrible error handling
    }
  
  return pOutStream;
}

void UrlFile::SetDescription (const string& strDescription)
{
  m_strDescription = strDescription;
}

string UrlFile::GetRelativePathToItem (const UrlItem* pTo) const
{
  if (m_pParent)
    return m_pParent->GetRelativePathToItem(pTo);
  else
    return UrlItem::GetRelativePathToItem(pTo);
}





