/*  createhtml - library to generate html files
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// UrlFile.h: interface for the UrlFile class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__URL_FILE_H__INCLUDED_)
#define __URL_FILE_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// #include "Common.h" // dep_chk_unknown 
#include "UrlItem.h" // dep_chk_needed 

#include <fstream>

using namespace std;

class UrlFolder;

class UrlFile : public UrlItem
{
public:
	UrlFile(const string& strName);
//	UrlFile(const char);
	virtual ~UrlFile();

protected:
	string m_strDescription;

public:
	void SetDescription (const string& strDescription);
	string GetDescription () { return m_strDescription; }

public:
	ofstream* GetOutStream ();

public:
	virtual string GetRelativePathToItem (const UrlItem* pTo) const;

};

#endif // !defined(__URL_FILE_H__INCLUDED_)
