/*  createhtml - library to generate html files
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// UrlFolder.h: interface for the UrlFolder class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__URL_FOLDER_H__INCLUDED_)
#define __URL_FOLDER_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "UrlFile.h" // dep_chk_needed 

#include <vector>

using namespace std;

class UrlFolder : public UrlItem
{
public:
	UrlFolder(const string& strName);
	virtual ~UrlFolder();

public:
	vector<UrlFolder*> m_vectFolders;
	vector<UrlFile*> m_vectFiles;

public:
	void Add (UrlFolder* pFile);
	void Add (UrlFile* pFile);

	UrlFolder* AddFolder (const string& strName);
	UrlFile* AddFile (const string& strName);
	UrlFile* AddFile (const string& strName,const string& strDescription);
	UrlFile* AddIndexFile (const string& strDescription);

public:
	UrlFile* GetIndexFile ();


};

#endif // !defined(__URL_FOLDER_H__INCLUDED_)
