/*  disasmviewer, part of exmhcg - executable program tuner
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


//import CodeSnippet;
import java.util.*;

public class AsmCodeSnippet extends CodeSnippet
{
	Integer nOffset;
	Vector vectInstrs = new Vector();
	
	void setOffset (int offset)
		{
			nOffset = new Integer(offset);
	
		}
	
	void addInstr(AsmInstr instr)
		{
			vectInstrs.add (instr);				
		}
	
	String getPrefName ()
		{
			if (nOffset != null)
				{
					// return the preferred public name
					// all we know is the id, so return that
					// but subclasses may have better ideas
					
					return CisBetter.sprintf("0x%08x",nOffset);
				}
			else
				return super.getPrefName();
		}
/*	
	String DebugContents()
		{
			String str = super.DebugContents();	
			
			str += CisBetter.sprintf("Offset:               %0x08x\n",nOffset);
			
			for (Iterator i = vectInstrs.iterator(); i.hasNext(); )
				{
					AsmInstr instr = (AsmInstr) i.next();
					
					str += instr.DebugContents ();					
				}
			
			return str;			
		}
*/
}
