/*  disasmviewer, part of exmhcg - executable program tuner
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//import Operand;

public class AsmInstr
{
	byte bCode[];	
	String strInstr;
	Operand opDest;
	Operand opSrc;
	Operand opSrc2;
	
	public void setCode(byte b[])
		{
			bCode = b;
		}
	
	public byte[] getCode()
		{
			return bCode;	
		}
	
	public void setInstr(String instr)
		{
			strInstr = instr;	
		}
	
	public void setOpDest(Operand op)
		{
			opDest = op;	
		}
	
	public void setOpSrc(Operand op)
		{
			opSrc = op;	
		}
	
	public void setOpSrc2(Operand op)
		{
			opSrc2 = op;	
		}
	
	public String getCodeAsText ()
		{
			if (bCode == null)
				return null;
				
			String str = "";
				
			for (int i = 0; i < bCode.length; i++)
				{
					if (i > 0)
						str += (i % 7 == 0 ? '\n' : ' ');					
					str += CisBetter.sprintf("%02x",bCode[i]);
				}
			return str;
		}

	public String getAsText ()
		{
			String str = CisBetter.sprintf("%-10s ",strInstr);
			
			boolean bPrevOp = false;
			
			if (opDest != null)
				{
					str += opDest.getAsText();
					bPrevOp = true;
				}
			if (opSrc != null)
				{
					if (bPrevOp)
						str += ',';
					str += opSrc.getAsText();
					bPrevOp = true;
				}
			if (opSrc2 != null)
				{
					if (bPrevOp)
						str += ',';
					str += opSrc2.getAsText();
				}
	
		return str;			
		}
/*	
	String DebugContents()
	{
		String str = "";
		
		if (bCode != null)
			{
				for (int i = 0; i < bCode.length; i++)
					str += CisBetter.sprintf("%02x ",bCode[i]);							
				str += '\n';				
			}
		
		str += "                     " + CisBetter.sprintf("%-10s ",strInstr);
		
		boolean bPrevOp = false;
		
		if (opDest != null)
			{
				str += opDest.DebugContents();
				bPrevOp = true;
			}
		if (opSrc != null)
			{
				if (bPrevOp)
					str += ',';
				str += opSrc.DebugContents();
				bPrevOp = true;
			}
		if (opSrc2 != null)
			{
				if (bPrevOp)
					str += ',';
				str += opSrc2.DebugContents();
			}
		str += '\n';

		return str;			
	}
*/
}
