/*  disasmviewer, part of exmhcg - executable program tuner
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


import java.util.*;

public class CodeSnippet
{
	String strId = null;
	
	CodeSnippet prev = null; // fall through behaviour
	CodeSnippet next = null; // fall through behaviour
	Vector vectInternalJumps = null;
	Vector vectExternalCalls = null;

	public void setId(String id)
	{
		strId = id;
	}

	String getPrefName ()
		{
			// return the preferred public name
			// all we know is the id, so return that
			// but subclasses may have better ideas
			
			return strId;			
		}
	
	public boolean isTarget()
		{
			return (vectInternalJumps != null) || (vectExternalCalls != null);			
		}
/*	
	String DebugContents()
	{
		String str = "";	
		
		str +=   "Id:                << " + strId + " >>\n";
		
		if (prev != null)
			str += "Fall through from: << "+prev.strId + " >>\n";
		if (next != null)
			str += "Falls through to:  << "+next.strId + " >>\n";
			
		if (vectInternalJumps != null)
			for (Enumeration i = vectInternalJumps.elements(); i.hasMoreElements(); )
				{
					CodeSnippet from = (CodeSnippet) i.nextElement();

				 	str += "Internal jmp from: << "+from.strId+ " >>\n";
				}

		if (vectExternalCalls != null)
			for (Enumeration i = vectExternalCalls.elements(); i.hasMoreElements(); )
				{
					External from = (External) i.nextElement();
			 		str += "External call frm: << "+from.strId + " >> ("+from.strName+" in "+from.strJdafFile+")\n";
				}		
		
		return str;
	}
*/
}
