/*  disasmviewer, part of exmhcg - executable program tuner
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


import java.awt.*;

public class DataTextLink extends DataTextOffset
	{
		String pre, post;
		int prewidth;
		int textwidth;
		
		DataTextLink(int c,String pr,String t,String po)
			{
				super(c,t,0,0);
				pre = pr;
				post = po;
			}

		DataTextLink(int c,String pr,String t,String po,int x,int y)
			{
				super(c,t,x,y);
				pre = pr;
				post = po;
			}

		int calcWidth(FontMetrics metrics)
			{
				prewidth = metrics.stringWidth (pre);
				textwidth = metrics.stringWidth (text);
				return xoffset + prewidth + textwidth + metrics.stringWidth (post);
			}
		
		static final Color linkcol = new Color (.3f,.3f,1);

		public void paint(Graphics g,DataRow row,DataPane pane)
			{
				int x = pane.nStartXCol[col]+xoffset;
				int y = row.y+pane.nBaselineY+yoffset;
				
				g.drawString(pre,x,y);					
				Color col = g.getColor ();
				g.setColor (linkcol);
				g.drawString(text,x += prewidth,y);					
				g.setColor (col);
				g.drawString(post,x + textwidth,y);					
				
				// System.out.println ("link: "+text+"  :"+textwidth);
			}
		
/*
		String text;
		int col;
		
		DataText(int c,String t)
			{
				col = c;
				text = t;	
			}
		
		public void paint(Graphics g,DataRow row,DataPane pane)
			{
				g.drawString(text,pane.nStartXCol[col],row.y+pane.nBaselineY);					
			}
*/
	}
