/*  disasmviewer, part of exmhcg - executable program tuner
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


import java.awt.*;

public class DataTextMultiLine extends DataText
	{	
		int breaks[];
	
		DataTextMultiLine(int c,String t)
			{
				super(c,t);
				calcBreaks();
			}
		
		void calcBreaks()
			{
				int i = -1;
				int nBreaks = 1;
				
				while ((i = text.indexOf('\n',i+1)) != -1)
					nBreaks++;	
					
				breaks = new int[nBreaks];

				i = -1;					
				nBreaks = 0;

				while ((i = text.indexOf('\n',i+1)) != -1)
					breaks[nBreaks++] = i;
				breaks[nBreaks++] = text.length();	
			}	
			
		int calcWidth(FontMetrics metrics)
			{
				int width = 0;
				int nNextBegin = 0;

				for (int i = 0; i < breaks.length; i++)
					{
						width = Math.max(width,metrics.stringWidth (text.substring(nNextBegin,breaks[i])));
						nNextBegin = breaks[i]+1;
					}
				return width;
			}
		
		public void paint(Graphics g,DataRow row,DataPane pane)
			{
				int y = row.y+pane.nBaselineY;
				int yadd = g.getFontMetrics().getHeight ();
				
				
				int nNextBegin = 0;
				for (int i = 0; i < breaks.length; i++)
					{
						g.drawString(text.substring(nNextBegin,breaks[i]),
												 pane.nStartXCol[col],y);					
						nNextBegin = breaks[i]+1;
						y += yadd;
					}
			}
	}
