/*  disasmviewer, part of exmhcg - executable program tuner
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


import java.awt.*;

public class DataTextOffset extends DataText
	{
		int yoffset;
		int xoffset;
		
		DataTextOffset(int c,String t)
			{
				super(c,t);
				xoffset = 0;
				yoffset = 0;
			}

		DataTextOffset(int c,String t,int x,int y)
			{
				super(c,t);
				xoffset = x;
				yoffset = y;
			}

		int calcWidth(FontMetrics metrics)
			{
				return xoffset + metrics.stringWidth (text);
			}
		
		void rightAlign (int widthCol,FontMetrics metrics)
			{
				xoffset = widthCol - calcWidth(metrics);	
			}
		
		public void paint(Graphics g,DataRow row,DataPane pane)
			{
				int x = pane.nStartXCol[col]+xoffset;
				int y = row.y+pane.nBaselineY+yoffset;
				
				g.drawString(text,x,y);					
			}
		
/*
		String text;
		int col;
		
		DataText(int c,String t)
			{
				col = c;
				text = t;	
			}
		
		public void paint(Graphics g,DataRow row,DataPane pane)
			{
				g.drawString(text,pane.nStartXCol[col],row.y+pane.nBaselineY);					
			}
*/
	}
