/*  disasmviewer, part of exmhcg - executable program tuner
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * DisAsmViewer.java
 */
 
import java.awt.*;
import java.applet.*;
import java.net.*;
import java.io.*;

public class DisAsmViewer extends Applet
{
	TopLevelPanel tplPanel;
	
	public void init()
	{		
	
		System.out.println (getGraphics());
	
		try
			{
				URL urlDocBase = getDocumentBase();
				
				DisAsmData data = FileManager.readDisAsmData (urlDocBase);
				
				tplPanel = new TopLevelPanel();
				
				add (tplPanel);				

				tplPanel.init (data);
				
				// everything worked, add us				
				
				System.out.println ("about to setLayout (new GridLayout ())...");

				setLayout (new GridLayout ());
/*
				System.out.println ("creating debug...");
				String strDebugFile = tplPanel.data.DebugContents ();
				System.out.println ("displaying debug...");
				System.out.println ("File contents:\n\n"+strDebugFile+"\n");				
				System.out.println ("initialization finished...");
*/
			}
		catch (Exception ex)
			{
				setLayout (new GridLayout ());

				TextArea taError = new TextArea("Failed initialization...\n\n");
				taError.setEditable (false);
				add(taError);
				
				String strMessage = ex.getMessage();
				if (strMessage != null)
					taError.append ("Trouble: "+strMessage+"\n\n");
					
				StringWriter strStackTrace = new StringWriter();
				ex.printStackTrace (new PrintWriter(strStackTrace));
				taError.append (strStackTrace+"\n");				
				
				if (tplPanel != null &&
						tplPanel.data != null)
					{
//						String strDebugFile = tplPanel.data.DebugContents ();
//						taError.append ("File contents:\n\n"+strDebugFile+"\n");				
					}

				ex.printStackTrace ();
			}	
	
	/*
		Tester t = new Tester();
		
		t.test();	
	*/
	}

	public String getAppletInfo()
	{
		return "DisAsmViewer, 2002";	
	}
}
