/*  disasmviewer, part of exmhcg - executable program tuner
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import java.net.*;
import java.io.*;
import java.util.*;

public class FileManager
{
    static Hashtable getOptionsFromUrlInvoced(URL urlInvoced)
    {
	String strInvoced = urlInvoced.getFile();
			
	System.out.println ("Invocation: "+strInvoced);

	Hashtable options = new Hashtable();		
			
	int index, index2;
			
	if ((index = strInvoced.indexOf('?')) != -1)
	    {
		strInvoced = strInvoced.substring(index+1);		
					
		while ((index = strInvoced.indexOf('&')) != -1)					
		    {
			String opt = strInvoced.substring(0,index);										
							
			if ((index2 = opt.indexOf('=')) != -1)
			    options.put(opt.substring(0,index2),opt.substring(index2+1));					
			strInvoced = strInvoced.substring(index+1);		
		    }
		if ((index2 = strInvoced.indexOf('=')) != -1)
		    options.put(strInvoced.substring(0,index2),strInvoced.substring(index2+1));					
	    }
	System.out.println ("Options: "+options);
	return options;
    }
	
    static String convEscapes(String str)
    {
	int nFromIndex = 0;
	int nIndex;
	
	while ((nIndex = str.indexOf('%',nFromIndex)) != -1)
	    {
		System.out.println ("str: "+str+"   "+nIndex+"/"+nFromIndex);
		String strNo = str.substring(nIndex+1,nIndex+3);
					
		int nNo;
					
		try
		    {
			nNo = Integer.parseInt(strNo,16);
		    }
		catch (NumberFormatException ex)
		    {
			nFromIndex = nIndex+1;
			break;							
		    }					
		char ch = (char) nNo;
		str = str.substring(0,nIndex)+ch+str.substring(nIndex+3);							
					
		nFromIndex = nIndex+1;					
	    }
	return str;
    }
	
    static public DisAsmData readDisAsmData(URL urlInvoced) throws Exception
    {
	Hashtable opts = getOptionsFromUrlInvoced(urlInvoced);
		
	String strFile = (String) opts.get("file");

	if (strFile == null)
	    throw new Exception("No filename given!");

	strFile = convEscapes(strFile);
		
	System.out.println ("File: "+strFile);

	InputStream in;
		
	try
	    {		
		URL urlFile = new URL(urlInvoced,strFile);

		System.out.println ("File URL: "+urlFile);

		in = urlFile.openStream();
	    }
	catch (MalformedURLException ex) { throw ex; }
	catch (IOException ex) { throw ex; }
						
	DisAsmData data = new DisAsmData();
		
	DisAsmDataReader reader = new DisAsmDataReader(in,data);
		
	try
	    {				
		reader.readData();		
	    }
	catch (Exception ex)
	    {
		// String strDebugFile = data.DebugContents ();
		// System.out.println ("File contents so far:\n\n"+strDebugFile+"\n");				
		
		throw ex;
	    }
	return data;
    }

}
