/*  disasmviewer, part of exmhcg - executable program tuner
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


import java.util.*;

public class JumpAnchor
{
	static final int INCOMING = 0;
	static final int OUTGOING = 1;
	
	Vector vectArrowAnchors[][] = new Vector[2][2];
	
	public void addArrow(JumpArrowAnchor arrow,int type,int index)
		{
			if (vectArrowAnchors[type][index] == null)
				vectArrowAnchors[type][index] = new Vector();
			vectArrowAnchors[type][index].add (arrow);
//
//		System.out.println ("adding "+type+" "+index+" -> "+vectIncoming[type][index].size());
		}
	
	public int getNum(int type)
		{
			int nNum = 0;
			
			for (int i = 0; i < 2; i++)
				if (vectArrowAnchors[type][i] != null)
					nNum = Math.max(nNum,vectArrowAnchors[type][i].size());
					
			return nNum;			
		}	
		
	public void setRow(DataRow row,int offset)
		{
			for (int i = 0; i < 2; i++)
				{
					Vector v_in = vectArrowAnchors[INCOMING][i];
					Vector v_out = vectArrowAnchors[OUTGOING][i];
					
					if (v_out != null)
						{
							for (int j = 0; j < v_out.size(); j++)
								{
									JumpArrowAnchor arrowAnchor = (JumpArrowAnchor) v_out.elementAt(j);
									
									arrowAnchor.row = row;
									arrowAnchor.row_offset = (int) ((j+.5)*offset);
								}
							row.minHeight (offset*(v_out.size()));
						}
					
					if (v_in != null)
						{
							int in_move_up = (v_out == null ? 0 : 1);
							for (int j = 0; j < v_in.size(); j++)
								{
									JumpArrowAnchor arrowAnchor = (JumpArrowAnchor) v_in.elementAt(j);
									
									arrowAnchor.row = row;
									arrowAnchor.row_offset = (int) ((.5-j-in_move_up)*offset);
								}
							row.minLeading (offset*(v_in.size()-1+in_move_up));
						}
				}
/*			
				for (int t = 0; t < 2; t++)
					if (vectArrowAnchors[t][i] != null)
						{
							System.out.println ("having "+t+" "+i);

							for (int j = 0; j < vectArrowAnchors[t][i].size(); j++)
								{
									System.out.println ("calling "+t+" "+i+" "+j);

									JumpArrowAnchor arrowAnchor = (JumpArrowAnchor) vectArrowAnchors[t][i].elementAt(j);
									
									arrowAnchor.row = row;
									if (t == INCOMING)
										arrowAnchor.row_offset = (int) ((.5-j)*offset);
									else
										arrowAnchor.row_offset = (int) ((j+.5)*offset);
								}
						}
	*/
		}
}
