/*  disasmviewer, part of exmhcg - executable program tuner
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


import java.awt.*;
import java.awt.event.*;

public class PopupMenuHelper extends PopupMenu implements MouseListener
{
	private Component comp;
	
	public PopupMenuHelper(Component c)
	{
		// TODO: Add your code here
		
		super ();
		
		comp = c;		
		comp.add (this);
		comp.addMouseListener (this);		
	}	
	
	public void mouseClicked(MouseEvent e) { popup (e); }
	public void mousePressed(MouseEvent e) { popup (e); }
	public void mouseReleased(MouseEvent e) { popup (e); }
	public void mouseEntered(MouseEvent e) { }
	public void mouseExited(MouseEvent e) { }
	
	public void popup (MouseEvent e)
		{
			if (e.isPopupTrigger ())
				show (comp,e.getX(),e.getY());		
		}
	
	MenuItem addItem(ActionListener listener,String label)
		{
			MenuItem item = new MenuItem(label);
			add(item);			
			item.addActionListener (listener);
			return item;	
		}
	
	CheckboxMenuItem addCheckbox(ItemListener listener,String label)
		{
			CheckboxMenuItem item = new CheckboxMenuItem(label);
			add(item);			
			item.addItemListener (listener);
			return item;	
		}

}
