/*  disasmviewer, part of exmhcg - executable program tuner
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


class Tester
{
	static int sno = 0;

	public class a
		{
			int no;
			
			a()
				{
					no = sno;
					sno++;
				}
			
			b b_1;
				
			public String toString()
				{
					return "a::no = "+no;	
				}			
		}
	
	public class b
		{
			int no;

			a a_1;
			
			b()
				{
					no = sno;
					sno++;
				}

			public String toString()
				{
					return "b::no = "+no;	
				}			
		}
	
	
	
	
	
	public void test()
		{
			System.out.println ("*** Starting ***");	
			
			a a_ = new a();
			b b_ = new b();
			a a__ = new a();
			b b__ = new b();
			
			System.out.println ("a_  "+a_);	
			System.out.println ("b_  "+b_);	
			System.out.println ("a__ "+a_);	
			System.out.println ("b__ "+b_);	
			
			a_.b_1 = b_;
			b_.a_1 = a_;
			
			System.out.println ("a_.b_1  "+a_.b_1);	
			System.out.println ("b_.a_1  "+b_.a_1);	
			
			a_.no = 5;
			b_.no = 6;
			
			System.out.println ("a_  "+a_);	
			System.out.println ("b_  "+b_);	
			System.out.println ("a_.b_1  "+a_.b_1);	
			System.out.println ("b_.a_1  "+b_.a_1);	
			
			
			
			System.out.println ("*** Finished ***");	
		}
}
