/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// AnyInstruction.cpp: implementation of the AnyInstruction class.
//
//////////////////////////////////////////////////////////////////////

#include "AnyInstruction.h" // dep_chk_needed     
#include "Operand.h" // dep_chk_unknown   

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

AnyInstruction::AnyInstruction()
{
  m_pDestOp = NULL;
  m_pSrcOp = NULL;
  m_pSrc2Op = NULL;
  /*
    m_bSpecial = 0;
  */
}

AnyInstruction::~AnyInstruction()
{
  delete m_pDestOp;
  delete m_pSrcOp;
  delete m_pSrc2Op;
}

char* AnyInstruction::GenInstrAsmString (char* pDest) const
{
/*
	if (m_bSpecial & ANY_INSTR_LOCKED)
		pDest = OutString (pDest,"LOCK ");
	else if (m_bSpecial & ANY_INSTR_SOME_REP)
	{
		pDest = OutString (pDest,"REP");

		if ((m_bSpecial & ANY_INSTR_REP_MASK) == ANY_INSTR_REPE)
			*(pDest++) = 'E';
		else if ((m_bSpecial & ANY_INSTR_REP_MASK) == ANY_INSTR_REPNE)
		{
			*(pDest++) = 'N';
			*(pDest++) = 'E';
		}

		*(pDest++) = ' ';
	}	
*/
  pDest = Instruction::GenInstrAsmString (pDest);
  
  return pDest;
}

char* AnyInstruction::GenOpAsmString (char* pDest) const
{
/*
	if (m_bSpecial & ANY_INSTR_LOCKED)
		pDest = OutString (pDest,"LOCK ");
	else if (m_bSpecial & ANY_INSTR_SOME_REP)
	{
		pDest = OutString (pDest,"REP");

		if ((m_bSpecial & ANY_INSTR_REP_MASK) == ANY_INSTR_REPE)
			*(pDest++) = 'E';
		else if ((m_bSpecial & ANY_INSTR_REP_MASK) == ANY_INSTR_REPNE)
		{
			*(pDest++) = 'N';
			*(pDest++) = 'E';
		}

		*(pDest++) = ' ';
	}	
*/	
  pDest = Instruction::GenOpAsmString (pDest);
  
  if (m_pDestOp)
    pDest = m_pDestOp->GenAsmString (pDest);
  if (m_pSrcOp)
    {
      if (m_pDestOp)
	*(pDest++) = ',';
      pDest = m_pSrcOp->GenAsmString (pDest);
    }
  if (m_pSrc2Op)
    {
      assert (m_pSrcOp);
      *(pDest++) = ',';
      pDest = m_pSrc2Op->GenAsmString (pDest);
    }
  return pDest;
}











