/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// AnyInstruction.h: interface for the AnyInstruction class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__ANY_INSTRUCTION_H__INCLUDED_)
#define __ANY_INSTRUCTION_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Instruction.h"

/*
  I've changed so that LOCK and REP prefixes change the actual instruction number,
  e.g. instrADD to instrLOCK_ADD, so we do not have to keep track of lock and
  repeat prefixes. This was possible as there are not so many instructions that
  can have those prefixes.
  
  I've for now kept the old system (commented) which required and extra byte in 
  the AnyInstruction container to keep track of any prefixes.
  
  #define ANY_INSTR_LOCKED		0x10
  
  #define ANY_INSTR_SOME_REP		0x20
  
  #define ANY_INSTR_REP			0x20
  #define ANY_INSTR_REPE			0x21
  #define ANY_INSTR_REPNE			0x22
  
  #define ANY_INSTR_REP_MASK		0x23
*/

class AnyInstruction : public Instruction  
{
 public:
  AnyInstruction();
  virtual ~AnyInstruction();
  
 public:
  Operand* m_pDestOp;
  Operand* m_pSrcOp;
  Operand* m_pSrc2Op;
  /*
    byte	m_bSpecial;
  */
 public:
  void SetDestOp (Operand* pOp) { assert (!m_pDestOp);  m_pDestOp = pOp; }
  void SetSrcOp (Operand* pOp) { assert (!m_pSrcOp);  m_pSrcOp = pOp; }
  void SetSrc2Op (Operand* pOp) { assert (!m_pSrc2Op);  m_pSrc2Op = pOp; }
  /*
    void SetLocked () { m_bSpecial |= ANY_INSTR_LOCKED; }
    void SetRepeat (byte bRepeat) { m_bSpecial |= bRepeat; }
  */
  /*
    public:
    virtual byte GetRepLock () const { return m_bSpecial; }
  */
 public:
  virtual const Operand* GetDestOp () const { return m_pDestOp; }
  virtual const Operand* GetSrcOp () const { return m_pSrcOp; }
  virtual const Operand* GetSrc2Op () const { return m_pSrc2Op; }
  
 protected:
  virtual char* GenInstrAsmString (char* pDest) const;
  virtual char* GenOpAsmString (char* pDest) const;
};

#endif // !defined(__ANY_INSTRUCTION_H__INCLUDED_)
