/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// BitField.cpp: implementation of the BitField class.
//
//////////////////////////////////////////////////////////////////////

#include "BitField.h"

#include <stdlib.h>
#include <memory.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

BitField::BitField()
{
  m_pData = NULL;
  m_nSize = 0;
}

BitField::BitField(unsigned int nSize)
{
  m_pData = NULL;
  SetSize (nSize);
}

BitField::~BitField()
{
  free (m_pData);
}

void BitField::SetSize(unsigned int nSize)
{
  free (m_pData);
  unsigned int nAlloc = ((nSize + sizeof (unsigned int) - 1) / 
			 sizeof (unsigned int)) * sizeof (unsigned int);
  m_pData = (unsigned int*) malloc (nAlloc);
  memset (m_pData,0,nAlloc);
  m_nSize = nSize;
}


