/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// BitField.h: interface for the BitField class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__BIT_FIELD_H__INCLUDED_)
#define __BIT_FIELD_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <assert.h>

class BitField  
{
 public:
  BitField();
  BitField(unsigned int nSize);
  virtual ~BitField();
  
 public:
  void SetSize (unsigned int nSize);
  
 public:
  unsigned int* m_pData;
  unsigned int m_nSize;

 public:
  void SetBit(unsigned int nBit)
    {
      assert(nBit < m_nSize);
      // we assume compiler is smart enough to replace / and % with >> and &
      // otherwise, we should be (when finished)
      *(m_pData+nBit/sizeof(unsigned int)) |= 
	(1 << (nBit % sizeof(unsigned int)));
    }
  bool GetBit(unsigned int nBit)
    {
      assert(nBit < m_nSize);
      // we assume compiler is smart enough to replace / and % with >> and &
      // otherwise, we should be
      
      return !!(*(m_pData+nBit/sizeof(unsigned int)) & 
		(1 << (nBit % sizeof(unsigned int))));
    }
  
};

#endif // !defined(__BIT_FIELD_H__INCLUDED_)
