/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// BranchTargetTrace.h: interface for the BranchTargetTrace class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__BRANCH_TARGET_TRACE_H__INCLUDED_)
#define __BRANCH_TARGET_TRACE_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "BranchTarget.h" // dep_chk_needed     
#include "CodeTrace.h" // dep_chk_needed     

class BranchTargetTraceSingle;

class BranchTargetTrace : public BranchTarget, 
			  public CodeTrace  
{
 public:
  BranchTargetTrace();
  virtual ~BranchTargetTrace();
  
 public:
  void Split (dword dwOffset,BranchTargetTrace* pNew,dword dwCodeTraceRVA);	
  /*
    public:
    BranchInstr* GetBranchInstr (); 
  */
  
 public:
  virtual void HtmlPlainDisAsm (HtmlPage& page,
				const ReportDisAsmInfo& reportDisAsmInfo) const;
  virtual void JdafDisAsm (JdafAsmCodeSnippet& snippet,
			   const ReportDisAsmInfo& reportDisAsmInfo) const;
  
 public:
  virtual dword GetLengthOfRawCode () const { return m_dwRawCodeLength; }
  
public:
  BranchTargetTraceSingle* ConvertToTraceSingle (BranchTargetTraceSingle** pLast);
  
  
};

//void PrintConversionInfo();

#endif // !defined(__BRANCH_TARGET_TRACE_H__INCLUDED_)
