/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// BranchTargetTraceSingle.cpp: implementation of the BranchTargetTraceSingle class.
//
//////////////////////////////////////////////////////////////////////

#include "BranchTargetTraceSingle.h" 
#include "BranchTargetTrace.h" 

#include "ReportDisAsmInfo.h"
#include "JavaDisAsmFile.h"

#include "DataAnalyseFunction.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

BranchTargetTraceSingle::BranchTargetTraceSingle()
{
  
}

BranchTargetTraceSingle::~BranchTargetTraceSingle()
{
  
}

#include "HtmlPage.h"
#include "HtmlTags.h" // dep_chk_unknown     

void BranchTargetTraceSingle::HtmlPlainDisAsm (HtmlPage& page,
					       const ReportDisAsmInfo& reportDisAsmInfo) const
{	
  BranchTarget::HtmlPlainDisAsm(page,reportDisAsmInfo);
  
  dword dwVA;
  bool bVA = reportDisAsmInfo.GetOffset(this,dwVA);
  
  // byte* pRawCode = m_pRawCode;
  
  assert (m_pSource || m_pPrev);
  bool bFullAddress = !!m_pSource;
  
  //////////////////////////////////////////////////////////
  
  BranchTarget::HtmlPlainDisAsm (page,m_pInstruction,m_pRawCode,m_bRawCodeLength,
                                 dwVA,bVA,bFullAddress,reportDisAsmInfo);
  
  if (reportDisAsmInfo.m_pAnalyseFunction)
    {
      MapBTOutgoingState::const_iterator outgoing = 
	reportDisAsmInfo.m_pAnalyseFunction->mapOutgoingState.find(this);
      
      page << "OUTGOING:\n";
      if (outgoing != 
	  reportDisAsmInfo.m_pAnalyseFunction->mapOutgoingState.end())
	outgoing->second->HtmlPlainDisAsm(page,reportDisAsmInfo,false);
      //page << "ENDOUTGOING:\n";
    }
  
#ifndef NDEBUG
  if (reportDisAsmInfo.m_pAnalyseFunction)
    {
      MapBTOutgoingState::const_iterator outgoingBranch = 
	reportDisAsmInfo.m_pAnalyseFunction->mapOutgoingStateBranch.find(this);
      
      assert (outgoingBranch == 
	      reportDisAsmInfo.m_pAnalyseFunction->mapOutgoingStateBranch.end());
      /*
	//page << "BRANCH:\n";
      if (outgoingBranch != reportDisAsmInfo.m_pAnalyseFunction->mapOutgoingStateBranch.end())
	outgoingBranch->second->HtmlPlainDisAsm(page,reportDisAsmInfo,true);
      //page << "ENDBRANCH\n";    
      */
    }
#endif
  /*
typedef map<const CtrlTransferTarget*,IncomingState> MapCTTIncomingState;
typedef map<const BranchTarget*,OutgoingState> MapBTOutgoingState;

  MapCTTIncomingState mapIncomingState;
  MapBTOutgoingState mapOutgoingState;
  */

  /*
                fmt2[0] = 0;
                char* ptr = fmt2;

                int l =  bLength;
                for (int k = 7; l && k; l--, k--)
                {
                        byte bByte = *(pRawCode++);				
                        ptr += sprintf (ptr,"%02x ",bByte);
                }

                pInstruction->InstrAsmString(fmt3);
                pInstruction->OpAsmString(fmt4);

                if (bFullAddress)
                        page.Begin(a().name(reportDisAsmInfo.GetLabel(this)));

                assert (bVA); // or cannot use dwVA
                sprintf (fmt,bFullAddress ? "0x%08lx  %-21s %-9s %s\n" :
                                                                         "  %8lx  %-21s %-9s %s\n",dwVA,fmt2,fmt3,fmt4);

                page << fmt;

                if (bFullAddress)
                        page.End();

                while (l)
                {
                        char* ptr = fmt2;
                        for (int k = 7; l && k; l--, k--)
                        {
                                byte bByte = *(pRawCode++);				
                                ptr += sprintf (ptr,"%02x ",bByte);
                        }
                        page << "            " << fmt2 << '\n';
                }
*/
//////////////////////////////////////////////////////////
  
}

void BranchTargetTraceSingle::JdafDisAsm (JdafAsmCodeSnippet& snippet,
					  const ReportDisAsmInfo& reportDisAsmInfo) const
{
  BranchTarget::JdafDisAsm (snippet,reportDisAsmInfo);
  
  JdafAsmInstr* pJdafInstr = 
    BranchTarget::JdafDisAsm (m_pInstruction,m_pRawCode,m_bRawCodeLength);
  
  snippet.AddInstruction(pJdafInstr);
}

BranchTargetTrace* BranchTargetTraceSingle::ConvertToTraceMultiple (BranchTargetTraceSingle* /* pLast */)
{
  
  
  
  
  return NULL;
}



