/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// CodeTrace.h: interface for the codeTrace class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__CODE_TRACE_H__INCLUDED_)
#define __CODE_TRACE_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GlobalDefs.h" 

class Instruction; 

#include <vector>

using namespace std;

typedef vector<byte> VectByte;
typedef vector<Instruction*> VectInstruction;

class CodeTrace  
{
 public:
  CodeTrace();
  virtual ~CodeTrace();
  
 protected:
  byte* m_pRawCode;
  
  dword m_dwRawCodeLength;
  
  VectByte m_vectRawInstrLengths;
  VectInstruction m_vectInstructions;
  
 public:
  void Split (dword dwOffset,CodeTrace* pNew,dword dwCodeTraceRVA);	
  
public:
  void AddInstruction (Instruction* pInstr,byte bLength) 
    { 
      m_vectInstructions.push_back (pInstr); 
      m_vectRawInstrLengths.push_back (bLength); 
    }
  
  void SetRawCode (const byte* pRawCode,dword dwLength);
  
  bool HasInstructions () { return !m_vectInstructions.empty(); }
  
};

#endif // !defined(__CODE_TRACE_H__INCLUDED_)
