/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// CodeTraceSingle.h: interface for the CCodeTraceSingle class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__CODE_TRACE_SINGLE_H__INCLUDED_)
#define __CODE_TRACE_SINGLE_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GlobalDefs.h" 

class Instruction; 

class CodeTraceSingle  
{
 public:
  CodeTraceSingle();
  virtual ~CodeTraceSingle();
  
 protected:
  byte* m_pRawCode;
  byte m_bRawCodeLength;
  
  Instruction* m_pInstruction;
  
 public:
  void SetInstruction (Instruction* pInstr) 
    { 
      assert (!m_pInstruction); 
      m_pInstruction = pInstr; 
    }
  
  void SetRawCode (const byte* pRawCode,byte bLength);
  
  byte GetRawCodeLength () const { return m_bRawCodeLength; }
  
  Instruction* GetInstruction () { return m_pInstruction; }
};

#endif // !defined(__CODE_TRACE_SINGLE_H__INCLUDED_)
