/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// DataDestPtr.h: interface for the DataDestPtr class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__DATA_DEST_PTR_H__INCLUDED_)
#define __DATA_DEST_PTR_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GlobalDefs.h" // dep_chk_needed     
#include <assert.h>
#include <string>

using namespace std;

class DataDestPtr  
{
 protected:
  DataDestPtr();
 public:
  DataDestPtr(void* pStart IFDEBUGPARAM(void* pEnd) );
  virtual ~DataDestPtr();
  
 public:
  byte* m_pStart;
  IFDEBUG(byte* m_pEnd);
  
  byte* m_pCurrent;
  
 public:
  void WriteByte (byte bData);
  void WriteBytes (byte bData1,byte bData2) 
    { WriteByte(bData1); WriteByte(bData2); }
  void WriteWord (word wData);
  void WriteDWord (dword dwData);
  
  void WriteDWordOffset (dword dwOffset,dword dwData);

  void WriteData (const void* pData,uint nLength);
  
  void WriteString (const string& str);
  void WriteString (const string& str,uint nAlignment);
  void WriteZero (uint nLength);
  
  void* WritePtr(uint nLength);
  
 public:
  void* GetCurrent () { return m_pCurrent ; } 
  void SetCurrent (void* pCur) 
    { 
      assert (pCur >= m_pStart && pCur <= m_pEnd); 
      m_pCurrent = (byte*) pCur; 
    }
  
  void ResetCurrent () { m_pCurrent = m_pStart; }
  
  dword GetOffset() { return m_pCurrent-m_pStart; }
  void SetOffset (dword dwOffset) 
    { 
      assert(m_pStart + dwOffset <= m_pEnd); 
      m_pCurrent = m_pStart + dwOffset; 
    }
  
 public:
#ifndef NDEBUG			
  bool ReacedEnd () { return m_pCurrent == m_pEnd; }
#endif
};

#endif // !defined(__DATA_DEST_PTR_H__INCLUDED_)
