/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// DataDestRelocPtr.h: interface for the DataDestRelocPtr class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__DATA_DEST_RELOC_PTR_H__INCLUDED_)
#define __DATA_DEST_RELOC_PTR_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DataDestPtr.h" 
class RelocationInfo; 

class RelocatableDest;

class DataDestRelocPtr : public DataDestPtr  
{
 protected:
  DataDestRelocPtr();
 public:
  DataDestRelocPtr(RelocatableDest* pDest);
  DataDestRelocPtr(void* pStart IFDEBUGPARAM(void* pEnd) ,
		   RelocationInfo* pReloc);
  DataDestRelocPtr(DataDestRelocPtr* pBase,
		   dword dwOffset IFDEBUGPARAM(dword dwSize) );
  virtual ~DataDestRelocPtr();
  
 public:
  RelocationInfo* m_pReloc;
  
  dword dwRVAOffset;
  
 public:
  void WriteDWord (dword dwData,word wRelocate);
  void WriteDWord (dword dwData) 
    { DataDestPtr::WriteDWord(dwData); } // because it's shadowed
  
  void InsertRelocation(dword dwOffset,word wRelocate);
  
 public:
  dword GetRVA() { return GetOffset() + dwRVAOffset; }
  
  
};

#endif // !defined(__DATA_DEST_RELOC_PTR_H__INCLUDED_)
