/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// DataPtr.cpp: implementation of the DataPtr class.
//
//////////////////////////////////////////////////////////////////////

#include "DataPtr.h" // dep_chk_needed   
#include <assert.h>
#include <stdio.h>
#include <string.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

DataPtr::DataPtr()
{
/*
	m_pStart = pStart;
	m_pEnd = pEnd;

	m_pCurrent = pStart;
*/
}

DataPtr::~DataPtr()
{
	
}

void DataPtr::GetData (void* pDest,uint nBytes)
{
  const void* pSrc = GetPtr(nBytes);
  
  memcpy (pDest,pSrc,nBytes);
}


/*
const void* DataPtr::GetPtr (int nBytes)
{
	assert (m_pStart <= m_pEnd);
	assert (m_pCurrent >= m_pStart && m_pCurrent <= m_pEnd);

	if (((const byte*) m_pCurrent) + nBytes > m_pEnd)
		throw "Attempt to read outside data source.";

	const void* ptr = m_pCurrent;
	
	m_pCurrent = ((const byte*) m_pCurrent) + nBytes;

	return ptr;
}
*/
/*
const char* DataPtr::GetString (dword dwOffset)
{
	assert (m_pStart <= m_pEnd);

	// we must first determine if string is withing bound
	//
	// cannot use strlen as it may wander of too far if string is not '\0'-terminated

	const char* pText = ((const char*) m_pStart) + dwOffset;

	for ( ; ; )
	{
		if ((const void*) pText >= m_pEnd ||
			(const void*) pText <= m_pStart) // take care of overflow
			throw "Attempt to read outside data source.";

		if (!(*pText))
			break;
		pText++;
	}

	return ((const char*) m_pStart) + dwOffset;
}


const char* DataPtr::GetString ()
{
	assert (m_pStart <= m_pEnd);
	assert (m_pCurrent >= m_pStart && m_pCurrent <= m_pEnd);

	// we must first determine if string is withing bound
	//
	// cannot use strlen as it may wander of too far if string is not '\0'-terminated

	const char* pText = ((const char*) m_pCurrent);
	const char* pStart = pText;

	for ( ; ; )
	{
		if ((const void*) pText >= m_pEnd ||
			(const void*) pText <= m_pStart) // take care of overflow
			throw "Attempt to read outside data source.";

		if (!(*pText))
			break;
		pText++;
	}

	m_pCurrent = pText;

	return pStart;
}
*/
/*
DataPtr DataPtr::GetDataPtr (dword dwStartOffset)
{
	assert (m_pStart <= m_pEnd);

	const void* pStart = ((const byte*) m_pStart) + dwStartOffset;

	if (pStart >= m_pEnd ||
		pStart < m_pStart) // take care of overflow
		throw "Attempt to read outside data source.";

	return DataPtr (pStart,m_pEnd);
}
*/

char* DataPtr::FormatAsHexBytes(dword dwBeginVA,dword dwEndVA,dword dwMaxBytes)
{
  assert (dwEndVA > dwBeginVA);
  
  dword dwLength = dwEndVA-dwBeginVA;
  
  if (dwLength > dwMaxBytes)
    dwLength = dwMaxBytes;
  
  char* fmt = new char[dwLength*3+1+3]; // + 1 for '\0' and 3 for possible ...
  
  char* ptr = fmt;
  
  const byte* pByte = (const byte*) GetPtr(dwBeginVA,dwEndVA-dwBeginVA);
  
  for ( ; dwLength; dwLength--, pByte++)
    {
      ptr += sprintf (ptr,"%02x ",*pByte);
      assert (ptr < fmt+(dwEndVA-dwBeginVA)*3+1);
    }
  
  *(ptr-1) = '\0';
  
  if (dwEndVA-dwBeginVA > dwLength)
    strcat (ptr-1,"...");
  
  return fmt; // reciever is responsible for deletion
}





