/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// DataPtr.h: interface for the DataPtr class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__DATA_PTR_H__INCLUDED_)
#define __DATA_PTR_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GlobalDefs.h" 

class DataPtr  
{
 public:
  DataPtr();
  virtual ~DataPtr();
  
 public:
  /*
        const void* m_pStart;
        const void* m_pEnd;
        
        const void* m_pCurrent;
  */
 public:
  byte GetByte () { return *((const byte*) GetPtr(sizeof (byte))); }
  word GetWord () { return *((const word*) GetPtr(sizeof (word))); }
  dword GetDWord () { return *((const dword*) GetPtr(sizeof (dword))); }
  
  byte GetByte (dword dwVirtualAddress) 
    { return *((const byte*) GetPtr(dwVirtualAddress,sizeof (byte))); }
  word GetWord (dword dwVirtualAddress) 
    { return *((const word*) GetPtr(dwVirtualAddress,sizeof (word))); }
  dword GetDWord (dword dwVirtualAddress) 
    { return *((const dword*) GetPtr(dwVirtualAddress,sizeof (dword))); }
  
  void GetData (void* pDest,uint nBytes);
  
  virtual const byte* GetPtr (uint nBytes) = 0;
  virtual const byte* GetPtr (dword dwVirtualAddress,uint nBytes) = 0;
  
  virtual bool IsValidAddress (dword dwVirtualAddress) = 0;
  
  virtual dword GetRVA () = 0;
  /*
    const char* GetString ();
    
    const char* GetString (dword dwStartOffset);
    
    virtual DataPtr GetOffsetDataPtr (dword dwStartOffset);
  */
  
 public:
  char* FormatAsHexBytes(dword dwBeginVA,dword dwEndVA,dword dwMaxBytes = 32);
};

#endif // !defined(__DATA_PTR_H__INCLUDED_)
