/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// DataPtrPESectionBody.h: interface for the DataPtrPESectionBody class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__DATA_PTR_P_E_SECTION_BODY_H__INCLUDED_)
#define __DATA_PTR_P_E_SECTION_BODY_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class PEFileSectionBody; 
#include "DataPtr.h" 

class DataPtrPESectionBody : public DataPtr
{
 public:
  DataPtrPESectionBody(PEFileSectionBody* pDataSrc,dword dwVirtualAddress);
  virtual ~DataPtrPESectionBody();
  
 public:
  PEFileSectionBody* m_pDataSrc;
  
  const byte* m_pCurrent;
  
 public:
  virtual const byte* GetPtr (uint nBytes);
  virtual const byte* GetPtr (dword dwVirtualAddress,uint nBytes);
  
  virtual bool IsValidAddress (dword dwVirtualAddress);
  virtual bool IsValidAddress (dword dwVirtualAddress,dword dwSize);
  
  virtual dword GetRVA ();
  
 public:
  const char* GetString ();
  const char* GetString (dword dwVirtualAddress);
  
  DataPtrPESectionBody* GetRVADataPtr (dword dwVirtualAddress);
  
};

#endif // !defined(__DATA_PTR_P_E_SECTION_BODY_H__INCLUDED_)
