/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// DestRelocatableSections.h: interface for the DestRelocatableSections class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__DEST_RELOCATABLE_SECTIONS_H__INCLUDED_)
#define __DEST_RELOCATABLE_SECTIONS_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GlobalDefs.h"
#include "RelocationInfo.h"

#include <map>

using namespace std;

class RelocatableDest;

typedef map<word,RelocatableDest*> MapSectionRelocatableDest;
typedef map<dword,RelocatableDest*> MapOffsetRelocatableDest;

class DestRelocatableSections  
{
 public:
  DestRelocatableSections();
  virtual ~DestRelocatableSections();
  
 public:
  MapSectionRelocatableDest mapSectionRelocatableDest;
  
  MapDoRelocation mapDoRelocation;
  
 public:
  bool HasSection(word wRelocate);

  dword GetSectionFileLength(word wRelocate);
  dword GetSectionImageLength(word wRelocate);
  dword GetSectionFileEnd(word wRelocate);
  dword GetSectionImageEnd(word wRelocate);
  
  word GetSectionFirstInRange (word wRelocMin,word wRelocMax);
  
  dword AlignSectionFileLength (word wRelocate,dword dwAlign);
  
  void AddRelocatableDest(word wRelocate,RelocatableDest* pDest);
  
  void AppendToEnd (word wRelocateAppendTo,word wRelocateSrc,dword dwAlign);
  
  void RelocateSection(word wRelocate,dword dwNewSectionBase);
  void DoRelocations ();
  
  const RelocatableDest* GetRelocatableDest(word wRelocate);
  
 protected:
  void AddDoRelocate (word wRelocate,dword dwMove,word wAppendedTo = 0);
  
 public:
  void GetSectionInFileOrder(MapOffsetRelocatableDest& mapOffsetRelocatableDest);

#ifndef NDEBUG
  void VerifyIntegrity(uint no = 0);
#endif 
  
};

#endif // !defined(__DEST_RELOCATABLE_SECTIONS_H__INCLUDED_)
