/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// Elf32_ProgramBlock.h: interface for the Elf32_ProgramBlock class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__ELF32_PROGRAM_BLOCK_H__INCLUDED_)
#define __ELF32_PROGRAM_BLOCK_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GlobalDefs.h"
#include "ELF_File.h"
#include "FileMapItem.h"

//////////////////////////////////////////////////////////////////////

#include <map>

using namespace std;

class Elf32_ProgramBlock;

class WriteProgramHeader;

typedef vector<Elf32_Section*> VectSections;

class Elf32_ProgramBlock : public FileMapItem
{
 public:
  Elf32_ProgramBlock();
  Elf32_ProgramBlock(Elf32_Word type,Elf32_Word flags);
  virtual ~Elf32_ProgramBlock();
  
 public:
  Elf32_ProgramHeader m_header;
  // const byte* m_pData;
  
    WriteProgramHeader* m_pWriteHeader;

 public:
  void InitData (const Elf32_ProgramHeader* header/*,const void *pData*/);

 public:
  void ValidateHeader();

 public:
  RelocatableDest* WriteHeader ();
     /*
       WriteProgramHeader* CreateProgramHeader(Elf32_Word type,Elf32_Word flags,word wRelocStarts);
*/
     
  void SetBlockRange();

 public:
  VectSections m_vectSections;

 public:
  bool IsSectionInside (const Elf32_Section* sect);

 public:
  void AddSection (Elf32_Section* pSection);

 public:
  void AddLoadSection (Elf32_Section* pSection);

 public:
  void SetSection (Elf32_Section* pSection,Elf32_Word type,Elf32_Word flags);

  //  public:
  // virtual void ReadInitData (const Elf32_ProgramBlockHeader& header,int file);

 protected:
  virtual bool ValidateCoExistence (FileMapItem* pOtherItem);
  
 public:
  virtual string GetDescription();

};

//////////////////////////////////////////////////////////////////////

#endif // !defined(__ELF32_PROGRAM_BLOCK_H__INCLUDED_)
