/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// ErrorContext.cpp: implementation of the ErrorContext class.
//
//////////////////////////////////////////////////////////////////////

#include "ErrorContext.h"  
#include "ErrorTracker.h"  

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ErrorContext::ErrorContext(word wContext)
{
  m_wContext = wContext;
  
  m_pParent = NULL;
}

ErrorContext::ErrorContext(word wContext,string strFile)
{
  m_wContext = wContext;
  m_strFile = strFile;
  
  m_pParent = NULL;
}

ErrorContext::~ErrorContext()
{

}

//////////////////////////////////////////////////////////////////////

PushErrorContext::PushErrorContext(word wContext)
{
  m_pContext = NULL;
  Push(wContext);
}

PushErrorContext::PushErrorContext(word wContext,string strFile)
{
  m_pContext = NULL;
  Push(wContext,strFile);
}

void PushErrorContext::Push(word wContext)
{
  assert (!m_pContext);
  m_pContext = new ErrorContext(wContext);
  
  errorTracker.PushContext(m_pContext);
}

void PushErrorContext::Push(word wContext,string strFile)
{
  assert (!m_pContext);
  m_pContext = new ErrorContext(wContext,strFile);
  
  errorTracker.PushContext(m_pContext);
}

PushErrorContext::~PushErrorContext()
{
  if (m_pContext)
    Pop();
  
  // note: we're not responsible for deletion of m_pContext, errorTracker is
}

void PushErrorContext::Pop()
{
  assert (m_pContext); // should not pop twice
  
  errorTracker.PopContext();
  
  m_pContext = NULL;
}



