/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// ErrorContext.h: interface for the ErrorContext class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__ERROR_CONTEXT_H__INCLUDED_)
#define __ERROR_CONTEXT_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//////////////////////////////////////////////////////////////////////

#include "GlobalDefs.h" // dep_chk_needed     
#include <string>

using namespace std;

#define CONTEXT_GENERAL			1
#define CONTEXT_READING_FILE		2
#define CONTEXT_READING_ACTUAL		3
#define CONTEXT_READING_POST		4 // processing data in executable, other than code (instructions)
#define CONTEXT_PROCESSING		5
#define CONTEXT_DISASSEMBLY		6
#define CONTEXT_DATA_ANALYSIS		7
#define CONTEXT_TUNING_FILE		8
#define CONTEXT_WRITING_FILE		9

class ErrorContext  
{
 public:
  ErrorContext(word wContext);
  ErrorContext(word wContext,string strFile);
  virtual ~ErrorContext();
  
 public:
  ErrorContext* m_pParent;
  
 public:
  word	m_wContext;
  string	m_strFile; // the file we're processing
};

class PushErrorContext
{
  // this class holds an error context while it is in scope, the
  // context as automatically deleted when it loses context (and if it
  // is an local automatic variable), if an error is thrown through it
  
  // it can also be popped by calling Pop

 public:
  PushErrorContext(word wContext);
  PushErrorContext(word wContext,string strFile);
  virtual ~PushErrorContext();
  
 public:
  void Push(word wContext);
  void Push(word wContext,string strFile);
  
 public:
  ErrorContext* m_pContext;
  
 public:
  void Pop();
};

#endif // !defined(__ERROR_CONTEXT_H__INCLUDED_)
