/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// ExportedObject.h: interface for the ExportedObject class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__EXPORTED_OBJECT_H__INCLUDED_)
#define __EXPORTED_OBJECT_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GlobalDefs.h"
#include "ExportedEntry.h" // dep_chk_needed     

// is the export an function or an object

#define EXPORT_FUNCTION_SHIFT    0
#define EXPORT_OBJECT_SHIFT      4

// and how sure are we

#define EXPORT_GUESS             0x01 // based on for example the section where it resides
#define EXPORT_GIVEN             0x02 // the export table said so (ELF only)
#define EXPORT_USAGE             0x04 // somebody used us that way

#define EXPORT_FUNC_GUESS        (EXPORT_GUESS << EXPORT_FUNCTION_SHIFT)
#define EXPORT_FUNC_GIVEN        (EXPORT_GIVEN << EXPORT_FUNCTION_SHIFT)
#define EXPORT_FUNC_USAGE        (EXPORT_USAGE << EXPORT_FUNCTION_SHIFT)

#define EXPORT_FUNC_MASK         0x0f

#define EXPORT_OBJECT_GUESS        (EXPORT_GUESS << EXPORT_OBJECT_SHIFT)
#define EXPORT_OBJECT_GIVEN        (EXPORT_GIVEN << EXPORT_OBJECT_SHIFT)
#define EXPORT_OBJECT_USAGE        (EXPORT_USAGE << EXPORT_OBJECT_SHIFT)

#define EXPORT_OBJ_MASK         0xf0

class ExportedObject : public ExportedEntry  
{
 public:
  ExportedObject(dword dwEntryRVA,dword dwEntrySize = 0);
  virtual ~ExportedObject();
  
 public:
  dword	m_dwEntryRVA;	// actual address of function or variable
  dword m_dwEntrySize;
  
 public:
  byte  m_bType; // function or object...
};

#endif // !defined(__EXPORTED_OBJECT_H__INCLUDED_)
