/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// FileMap.h: interface for the FileMap class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__FILE_MAP_H__INCLUDED_)
#define FILE_MAP_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FileMapItem.h"

#include <map>

using namespace std;

struct FileMapInfo
{
 public:
  FileMapInfo(dword dwSize,FileMapItem* pItem)
  { m_dwSize = dwSize; m_pItem = pItem; }
  
 public:
  dword m_dwSize;
  
  FileMapItem* m_pItem;
};

typedef map<dword,FileMapInfo> MapFileMapInfo;

class FileMap  
{
 public:
  FileMap();
  virtual ~FileMap();
  
 public:
  dword m_dwLength;
  MapFileMapInfo m_mapFileMapInfo;
  
 public:
  void SetFileLength(dword dwLength);

  void AddAreaType(dword dwOffset,dword dwSize,FileMapItem* pItem);
  
  void ValidateCoExistence(dword dwOffset,dword dwSize,FileMapItem* pItem);
  
 public:
  bool IsAreaUnused(dword dwOffset,dword dwSize);
  
};

#endif // !defined(FILE_MAP_H__INCLUDED_)

