/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// GUIResources.cpp: implementation of the GUIResources class.
//
//////////////////////////////////////////////////////////////////////

#include "GUIResources.h" 
#include "gen/GUIResourcesError.h" 
#include "gen/DataPtrSrcError.h" 
#include "DataPtrPESectionBody.h"  
#include "PEFileSectionBody.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GUIResources::GUIResources()
{

}

GUIResources::~GUIResources()
{

}

/*
void GUIResources::ReadDataDirectory(DataPtrPESectionBody* pDataPtr,GUIResReadingMaps& readingMaps)
{
	const ResourceDirectory* pDir = (const ResourceDirectory*) pDataPtr->GetPtr(sizeof (ResourceDirectory));

	if (!pDir->m_wNumNamed && !pDir->m_wNumIDd)
		throw "Resource Directory empty"; // why does it exist? // this could be an warning

	for (int i = 0; i < m_wNumNamed; i++)
	{


	}
}
*/
/*
struct GUIResReadingMaps
{
	MapRVAGUIResNameStr m_mapRVAGUIResNameStr;
	MapRVAGUIData       m_mapRVAGUIData;
	MapRVAGUIDataEntry  m_mapRVAGUIDataEntry;
	MapRVAGUIDataDirectory m_mapRVAGUIDataDirectory;
};
*/
/*
bool GUIResources::ReadResources (DataPtrPESectionBody* pDataPtr)
{
	// the four vectors in GUIResources
	//	VectGUIResNameStr m_vectResNameStr;
	//	VectGUIData       m_vectData;
	//	VectGUIDataEntry  m_vectDataDir;
	//	VectGUIDataDirectory m_vectGUIDataDirectory;
	//   are just to hold the data. When we read from the executable, we'll try to
	//   find duplicates. And if we do, we wont duplicate them, but rather
	//   use the same object.
	//   Things will be pushed onto the vectors in the order we found them, so if
	//   we traverse the tree in depth first order, (and output them in the order of
	//   the vectors) we'll at least output things so that lookup for the first things
	//   are close in the resource directory. And they will be close for the last things
	//   too, if there are not too many duplicates.
	//   There are two possible kinds of duplicates: object already pointed to from
	//   several points in the executable, these can without trouble be duplicated.
	//  Objects that really are duplicated. To make those into one could be a saving.
	//
	//   I do not know how much this can do, but it might be possible to find data objects
	//   that contain the same bit patterns. They could be condesed even further (when writing).
	//   The same can not be done with things containing RVAs, and the names will not condense well
	//   as they are prepended with words of length. This is not done.
	//
	//   The first objects of m_vectGUIDataDirectory, is the root directory.
	



	GUIResReadingMaps readingMaps;

	ReadDataDirectory (pDataPtr,readingMaps);





	return false;
}
*/

/*
	char* m_pResourceData;	
	RelocationInfo m_relocInfo;
	
public:
	bool FindRelocations (DataPtrPESectionBody* pDataPtr,dword dwImageBase);
*/

struct ResourceDirectory
{
  dword m_dwFlags;
  dword m_dwTimeDate;
  dword m_dwMajorMinor;
  word  m_wNumNamed;
  word  m_wNumIDd;
};

struct ResourceDirEntry
{
  dword m_dwNameRVAorID;
  dword m_dwEntryOffset;
};

struct ResourceDataEntry
{
  dword m_dwDataRVA;
  dword m_dwSize;
  dword m_dwCodepage;
  dword m_dwReserved;
};

struct FindRelocInfo
{
/*
  dword dwMinOffset;
  dword dwMaxOffset;
*/
  dword dwBaseRVA;
  
  RelocationInfo* pRelocInfo;
  
};

void FindRelocResDir(DataPtrPESectionBody* pDataPtr,FindRelocInfo& info);

void FindRelocCheckSubDirOrDataEntry(DataPtrPESectionBody* pDataPtr,
				     const ResourceDirEntry* pDirEntry,
				     FindRelocInfo& info)
{
  if (pDirEntry->m_dwEntryOffset & 0x80000000)
    {
      // sub directory
      
      FindRelocResDir (pDataPtr->GetRVADataPtr(info.dwBaseRVA+(pDirEntry->m_dwEntryOffset & 0x7fffffff)),info);
    }
  else
    {
      // data entry
      
      dword dwEntryRVA = info.dwBaseRVA+pDirEntry->m_dwEntryOffset;
      
      const ResourceDataEntry* pData = 
	(const ResourceDataEntry*) pDataPtr->GetPtr(dwEntryRVA,
						    sizeof (ResourceDataEntry));
      
      if (!pDataPtr->IsValidAddress(pData->m_dwDataRVA,pData->m_dwSize))
        throw ERROR_GUI_RES_RESOURCE_DATA_OUTSIDE_SECTION(pData->m_dwDataRVA,
							  dwEntryRVA);
      
      //this is just a sanity check. It could be removed (or made into warning)
      if (pData->m_dwReserved)
        throw ERROR_GUI_RES_RESOURCE_DATA_RESERVED_VALUE_NOT_ZERO(pData->m_dwReserved)->RVA(dwEntryRVA);
      
      // ok, so the RVA is at the position we just read, as it is the first member of ResourceDataEntry
      // and the position is dwOffset, and the relocation is relative to the current
      // segment, as we've been tracing our way here inside that
      
      // printf ("Data: %d @ %08x(%d)\n",pDirEntry->m_dwEntryOffset,pData->m_dwDataRVA,pData->m_dwSize);
      
      // DataPtrPESectionBody* pDataDataPtr = pDataPtr->GetRVADataPtr(pData->m_dwDataRVA);
      
      //for (int i = pData->m_dwSize; i; i--)
      //	printf ("%02x ",pDataDataPtr->GetByte());
      
      //printf ("\n");
      
      info.pRelocInfo->InsertRelocation(pDirEntry->m_dwEntryOffset,
					RELATIVE_IMAGE_CURRENT);
    }
}

void FindRelocResDir(DataPtrPESectionBody* pDataPtr,FindRelocInfo& info)
{
  dword dwDirRVA = pDataPtr->GetRVA();
  const ResourceDirectory* pDir = 
    (const ResourceDirectory*) pDataPtr->GetPtr(sizeof (ResourceDirectory));
  
  //this is just a sanity check. It could be removed (or made into warning)
  if (!pDir->m_wNumNamed && !pDir->m_wNumIDd)
    EMIT_ERROR(ERROR_GUI_RES_RESOURCE_DIR_EMPTY()->RVA(dwDirRVA)); // why does it exist?
  
  //printf ("Reda dir: %08x\n",pDataPtr->GetRVA());
  
  for (int named = 0; named < pDir->m_wNumNamed; named++)
    {
      dword dwDirEntryRVA = pDataPtr->GetRVA();
      const ResourceDirEntry* pDirEntry = 
	(const ResourceDirEntry*) pDataPtr->GetPtr(sizeof (ResourceDirEntry));
      
      //printf ("Named\n",pDataPtr->GetRVA());
      
      if (!(pDirEntry->m_dwNameRVAorID & 0x80000000))
        throw ERROR_GUI_RES_NAMED_RESOURCE_MISSING_NAMED_TAG()->RVA(dwDirEntryRVA);
      dword dwDataRVA = info.dwBaseRVA+
	(pDirEntry->m_dwNameRVAorID & 0x7fffffff); 
      if (pDataPtr->IsValidAddress(dwDataRVA))
        {
          // we should of course also check that the entire name is inside the
          // section, not just the beginning. But I do not know hos to know
          // if the name is stored as unicode or not
          throw ERROR_DATA_PTR_SRC_READING_OUTSIDE_SOURCE_REF(dwDataRVA,
							      dwDirEntryRVA);
        }
      FindRelocCheckSubDirOrDataEntry(pDataPtr,pDirEntry,info);
    }
  for (int idd = 0; idd < pDir->m_wNumIDd; idd++)
    {
      dword dwDirEntryRVA = pDataPtr->GetRVA();
      const ResourceDirEntry* pDirEntry =
	(const ResourceDirEntry*) pDataPtr->GetPtr(sizeof (ResourceDirEntry));
      
      //printf ("Id: %d\n",pDirEntry->m_dwNameRVAorID);
      
      if ((pDirEntry->m_dwNameRVAorID & 0x80000000))
        throw ERROR_GUI_RES_NUMBERED_RESOURCE_HAS_NAMED_TAG()->RVA(dwDirEntryRVA);
      if ((pDirEntry->m_dwNameRVAorID & 0xffff0000))
        throw ERROR_GUI_RES_NUMBERED_RESOURCE_OUTSIDE_ID_RANGE(pDirEntry->m_dwNameRVAorID)->RVA(dwDirEntryRVA);
      FindRelocCheckSubDirOrDataEntry(pDataPtr,pDirEntry,info);
    }
}

void GUIResources::FindRelocations (DataPtrPESectionBody* pDataPtr)
{
  m_relocInfo.m_dwImageOffset = pDataPtr->GetRVA();
  m_relocInfo.m_dwFileOffset = pDataPtr->m_pDataSrc->m_dwFileOffset;
  
  FindRelocInfo info;
/*
  info.dwMinOffset = 0;
  info.dwMaxOffset = 0;
*/
  info.dwBaseRVA = pDataPtr->GetRVA();
  
  info.pRelocInfo = &m_relocInfo;
  
  FindRelocResDir (pDataPtr->GetRVADataPtr(info.dwBaseRVA),info);
  
  
  
  
  
}





