#  exmhcg - executable program tuner  
#  Copyright (C) 2003  Hkan Johansson
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package GenCode;

use locale;
use strict;
use warnings;

BEGIN
{
    use Exporter   ();
    our ($VERSION, @ISA, @EXPORT, @EXPORT_OK, %EXPORT_TAGS);
    
    # set the version for version checking
    $VERSION     = 1.00;
    
    @ISA         = qw(Exporter); 
    @EXPORT      = qw(&GeneratedHeader &GeneratedHeaderH &GeneratedFooterH &ReadFile);
    %EXPORT_TAGS = ( );     # eg: TAG => [ qw!name1 name2! ],
    
    # your exported package globals go here,
    # as well as any optionally exported functions
    @EXPORT_OK   = qw();
}
our @EXPORT_OK;

END { }       # module clean-up code here (global destructor)

## YOUR CODE GOES HERE
##

sub GeneratedHeader($$)
{
    my $filename = shift;
    my $description = shift;

    my $t = '';

    $t .= ("// $filename: $description   \n".
	   "//                           \n".
	   "//////////////////////////////////////////////////////////////////////\n".
	   "//                                                                    \n".
	   "// This file is automatically generated by a script.                  \n".
	   "// Do not edit - useless.                                             \n".
	   "//                                                                    \n".
	   "//////////////////////////////////////////////////////////////////////\n".
	   "\n");

    return $t;
}

sub IncFileName($)
{
    my $incfile = shift;

    $incfile =~ s/.*\///;

    $incfile =~ s/\./\_/g;
    $incfile =~ s/([A-Z])/\_$1/g;
    $incfile = uc($incfile);
    
    $incfile = "_".$incfile."__INCLUDED_";

    return $incfile;
}

sub GeneratedHeaderH($$)
{
    my $filename = shift;
    my $description = shift;

    my $t = GeneratedHeader($filename,$description);
    
    my $incfile = IncFileName($filename);

    $t .= ("#if !defined($incfile)  \n".
	   "#define $incfile        \n".
	   "\n");

    return $t;
};


sub GeneratedFooterH()
{
    my $t = '';
    
    $t .= ("\n".
	   "#endif // !defined __<filename>__INCLUDED_ // this is a comment, so <filename> is OK!\n".
	   "\n".
	   "//////////////////////////////////////////////////////////////////////\n".
	   "\n");
    
    return $t;
};

sub ReadFile($)
{
    my $infile = shift;

    open(INFILE,"<$infile") || die "Can't open $infile";
    
    my $cont = "";
    
    while (<INFILE>)
    {
	$cont .= $_;
    }

    $cont =~ s/\r\n/\n/g;

    close(INFILE);

    return $cont;
}

##
## END OF CODE

1;  # don't forget to return a true value from the file
