/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// GlobalDefs.h: interface for the codeTrace class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__GLOBALDEFS_H__INCLUDED_)
#define __GLOBALDEFS_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <assert.h>

#ifndef NULL
#define NULL    0          
#endif

typedef unsigned int	uint;

typedef unsigned char	byte;  // 1 bytes
typedef unsigned short	word;  // 2 bytes
typedef unsigned int	dword; // 4 bytes

typedef signed char	sbyte;  // 1 bytes
typedef signed short	sword;  // 2 bytes
typedef signed int	sdword; // 4 bytes

#ifdef _MSC_VER
#pragma warning( disable : 4786 4788 )  // because of bad vc++ (gcc does better...)
#endif

#define FOR_EACH_ITER(              conttype,container,iter) for(conttype::iterator               iter = (container). begin(); iter != (container). end(); ++iter)
#define FOR_EACH_CONST_ITER(        conttype,container,iter) for(conttype::const_iterator         iter = (container). begin(); iter != (container). end(); ++iter)
#define FOR_EACH_ITER_REVERSE(      conttype,container,iter) for(conttype::reverse_iterator       iter = (container).rbegin(); iter != (container).rend(); ++iter)
#define FOR_EACH_CONST_ITER_REVERSE(conttype,container,iter) for(conttype::const_reverse_iterator iter = (container).rbegin(); iter != (container).rend(); ++iter)

// this is because I'd like     iter_erase = (set_or_map).erase(iter_erase);   better
#define SET_MAP_ERASE_CONTINUE_ITER(set_or_map,iter_erase) ((set_or_map).erase((iter_erase)++))  // although

#define SET_MAP_IF_FIND(conttype,container,iter,item) conttype::iterator iter = (container).find(item); if(iter != (container).end())

#define IS_TYPE(type,var) (dynamic_cast<type>(var))
#define ASSERT_IS_TYPE(type,var) assert(dynamic_cast<type>(var))
#define ASSERT_IS_TYPE_OR_NULL(type,var) assert(!(var) || dynamic_cast<type>(var))
#define ASSIGN_AND_ASSERT_IS_TYPE(type,var) (assert(dynamic_cast<type>(var)),(type)(var))

#ifndef NDEBUG			
#define DEFAULT_ASSERT_FALSE default:assert(false);break;
#define IFDEBUG(expr) expr;
#define IFDEBUGFIRSTPARAM(param) param
#define IFDEBUGPARAM(param) ,param
#else
#define DEFAULT_ASSERT_FALSE ;
#define IFDEBUG(expr) ;
#define IFDEBUGPARAM(param) 
#define IFDEBUGFIRSTPARAM(param) 
#endif

#ifndef NDEBUG		
#define verify(expr) assert(expr)	
#else
#define verify(expr) (expr)
#endif

// template<class A> void swap(A& a,A& b) { A c = a; a = b; b = c; }

#ifndef FOR_EACH_EXTRA_ARGS
#define FOR_EACH_EXTRA_ARGS

template<class __II, class __Fn, class __An1, class __An2> inline
__Fn for_each(__II __F, __II __L, __Fn __Op, __An1 __arg1, __An2 __arg2)
{for (; __F != __L; ++__F)
  __Op(*__F,__arg1,__arg2);
 return (__Op); }

template<class __II, class __Fn, class __An1> inline
__Fn for_each(__II __F, __II __L, __Fn __Op, __An1 __arg1)
{ for (; __F != __L; ++__F)
  __Op(*__F,__arg1);
 return (__Op); }

#endif // !defined(FOR_EACH_EXTRA_ARGS)

#endif // !defined(__GLOBALDEFS_H__INCLUDED_)




