/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// ImportedEntries.h: interface for the ImportedEntries class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__IMPORTED_ENTRIES_H__INCLUDED_)
#define __IMPORTED_ENTRIES_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GlobalDefs.h" 
#include "ImportedLibrary.h"
#include "ImportedEntry.h" 
#include "DataPtrPESectionBody.h"
#include <string>
#include <set>
#include <map>

class RelocatableDest;

using namespace std;

//#pragma warning( disable : 4786 )  

typedef vector<ImportedLibrary*> VectImportedLibrary;

typedef map<dword,dword> MapMovedImportAddressTableRVA;

extern MapMovedImportAddressTableRVA mapMovedImportAddressTableRVA;

class ImportedEntries  
{
 public:
  ImportedEntries();
  virtual ~ImportedEntries();

 public:
  VectImportedLibrary m_vectLibraries;
  VectImportedEntry m_vectImportedEntry;

 public:
  void AddFnc (ImportedEntry* pFnc,ImportedLibrary* pLib);
  void DeleteFnc (ImportedEntry* pFnc);

 public:
  void ReadPEImports (DataPtrPESectionBody* pDataPtr);

 protected:
  void ReadPEForwarderChain(set<dword>& nForwFuncs,
                          DataPtrPESectionBody* pDataPtr,
                          dword dwForwarder,dword dwForwarderRVA,
                          dword dwTableLength,
                          dword dwImportAddressTableRVA);


 public:
  RelocatableDest* WritePEImports ();

};

#endif // !defined(__IMPORTED_ENTRIES_H__INCLUDED_)
