/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// ImportedEntry.h: interface for the ImportedEntry class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__IMPORTED_ENTRY_H__INCLUDED_)
#define __IMPORTED_ENTRY_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GlobalDefs.h"

class ImportedLibrary; 

#include <string>

using namespace std;

#define IMPORT_FUNC_BY_ORDINAL_ONLY		0x80000000

class ImportedFunc;

class ImportedEntry
{
 public:
  ImportedEntry();
  virtual ~ImportedEntry();
  
 public:
  ImportedLibrary* m_pLibrary;
  string	m_strName;
  dword	m_dwBoundAddress;
  dword	m_nFunctionOrdinal; // with 0x8000000 if no name given
  bool	m_bForwarded; 
  
  dword	m_dwImportAddressTableRVA; // rva to this fncs 'ptr'
  
 public:
  ImportedFunc*	m_pAsFunction; // if we're used as a function
  
};

#endif // !defined(__IMPORTED_ENTRY_H__INCLUDED_)
