#!/usr/bin/perl

#  exmhcg - executable program tuner  
#  Copyright (C) 2003  Hkan Johansson
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

$infile = $ARGV[0];
$outfile = $ARGV[1];

$searchfor = $ARGV[2];
$counter = $ARGV[3];
$divide = $ARGV[4];

if (!defined($divide))
{ $divide = 1; }

print "Generating $outfile, $outfile2 from $infile\nSearchfor '$searchfor'.\n";

$searchfor =~ /([_a-zA-Z][_a-zA-Z0-9]*)$/;

$prefix = $1;
$regexp = "$`\($1\[_a-zA-Z0-9\]\*\)";

print "Prefix: '$1' Searchop: '$regexp' Count: '$counter' Divide: '$divide'\n";
 
open(INFILE,"<$infile") || die "Can't open $infile";

@groups = ();

$lastfound = 0;

while (<INFILE>)
{ 
    $readline = $_;

    if ($readline =~ /$regexp/)
    {
        push @groups , $1;
        push @groups , ($count);
        $lastfound = 1;
        if (!defined($counter))
        { $count++; }
    }
        elsif ($lastfound && $readline =~ /$counter/)
        {
                $count++;
        }
}

close(INFILE);

open(OUTFILE,">$outfile") || die "Can't open $outfile";

print OUTFILE <<"EndOfText";
// $outfile: indexes for $fullname names.
//
//////////////////////////////////////////////////////////////////////
//
// This file is automatically generated by a script.
// Do not edit - useless.
//
//////////////////////////////////////////////////////////////////////

EndOfText

while (@groups)
{
	$group = shift @groups;
    $cnt = shift @groups;
        
        print OUTFILE sprintf("#define %-20s %d\n",$group,$cnt/$divide);

}

print OUTFILE sprintf("\n#define %-20s %d\n","${prefix}NUM_GROUPS",$count/$divide);

print OUTFILE <<"EndOfText";

//////////////////////////////////////////////////////////////////////
EndOfText

close(OUTFILE);

