/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// InstructionEncoder.h: interface for the InstructionEncoder class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__INSTRUCTION_ENCODER_H__INCLUDED_)
#define __INSTRUCTION_ENCODER_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GlobalDefs.h"
#include "Instruction.h"
class DataDestPtr;

#include <vector>

using namespace std;
/*
struct InverseOpcodeInfo
{
	word m_nInstruction;

	byte m_nByte;
	byte m_nTagAndNNN;
};
*/

struct InverseOpcodeInfo
{
  // these are the same as in OpcodeInfo (except for m_nInstruction,
  // which isn't needed)
  
  dword	m_nArguments;	
  // word	m_nInstruction;
  
  byte	m_nExtra1;		
  byte	m_nExtra2;		
  
  // these are to know how to encode it again
  
  word m_nFlags;
  byte m_nByte;		// opcode byte
  byte m_nGroupNNN  : 3;	// index into group structure
  byte m_nSubGroupN : 3;	// index into subgroup structure or mmx/sse structure
};

struct InverseOpcodeInfoIndex
{
  word m_nInstruction;
  word m_nIndex;		// index into InverseOpcodeInfo array for first one of this type
};
//#define INVERSE_OPCODE_SUBGROUP_N_MASK			0x07
/* FAST_ENCODER_STUFF:
 *
 #define INVERSE_OPCODE_QUICK_ENCODER_N_SHIFT	4
*/
#define INVERSE_OPCODE_TAG_2_BYTE			0x0001
#define INVERSE_OPCODE_TAG_GROUP_MOD_11			0x0002
#define INVERSE_OPCODE_TAG_GROUP_MOD_MEM		0x0004
#define INVERSE_OPCODE_TAG_SUBGROUP			0x0008
#define INVERSE_OPCODE_TAG_MMX_SSE_PREFIX		0x0010

#define INVERSE_OPCODE_TAG_LOCK_REP_PREFIX		0x0020
//#define INVERSE_OPCODE_TAG_REPE_PREFIX		0x0040
//#define INVERSE_OPCODE_TAG_REPNE_PREFIX		0x0080

#define INVERSE_OPCODE_OP_MAY_BE_REG			0x0001
#define INVERSE_OPCODE_OP_MAY_BE_IMM			0x0002
#define INVERSE_OPCODE_OP_MAY_BE_MEM			0x0004

#define INVERSE_OPCODE_OP_DEST_SHIFT			6
#define INVERSE_OPCODE_OP_SRC_SHIFT			9 
#define INVERSE_OPCODE_OP_SRC2_SHIFT			12 

#define INVERSE_OPCODE_DEST_MASK			0x01c0
#define INVERSE_OPCODE_SRC_MASK				0x0e00
#define INVERSE_OPCODE_SRC2_MASK			0x3000

#define INVERSE_OPCODE_DEST_MAY_BE_REG			(INVERSE_OPCODE_OP_MAY_BE_REG << INVERSE_OPCODE_OP_DEST_SHIFT)
#define INVERSE_OPCODE_DEST_MAY_BE_IMM			(INVERSE_OPCODE_OP_MAY_BE_IMM << INVERSE_OPCODE_OP_DEST_SHIFT)
#define INVERSE_OPCODE_DEST_MAY_BE_MEM			(INVERSE_OPCODE_OP_MAY_BE_MEM << INVERSE_OPCODE_OP_DEST_SHIFT)

#define INVERSE_OPCODE_SRC_MAY_BE_REG			(INVERSE_OPCODE_OP_MAY_BE_REG << INVERSE_OPCODE_OP_SRC_SHIFT)
#define INVERSE_OPCODE_SRC_MAY_BE_IMM			(INVERSE_OPCODE_OP_MAY_BE_IMM << INVERSE_OPCODE_OP_SRC_SHIFT)
#define INVERSE_OPCODE_SRC_MAY_BE_MEM			(INVERSE_OPCODE_OP_MAY_BE_MEM << INVERSE_OPCODE_OP_SRC_SHIFT)

#define INVERSE_OPCODE_SRC2_MAY_BE_REG			(INVERSE_OPCODE_OP_MAY_BE_REG << INVERSE_OPCODE_OP_SRC2_SHIFT)
#define INVERSE_OPCODE_SRC2_MAY_BE_IMM			(INVERSE_OPCODE_OP_MAY_BE_IMM << INVERSE_OPCODE_OP_SRC2_SHIFT)

/* FAST_ENCODER_STUFF:
 *
#define INVERSE_OPCODE_TAG_HAS_QUICK_ENCODER		0x40
 */
#define INVERSE_OPCODE_TAG_HAS_MORE_VARIANTS		0x8000 // more of this instruction in InverseOpcodeInfo array

//////////////////////////////////////////////////////////////////////

#define DIL_DISP_IMM_START(disp_imm)   ((disp_imm) & 0x0f)

#define DIL_DISP_LEN(disp_imm)   ((disp_imm >> 4 ) & 0x0f)
#define DIL_IMM_LEN(disp_imm)    ((disp_imm >> 8 ) & 0x0f)
#define DIL_IMM2_LEN(disp_imm)   ((disp_imm >> 12) & 0x0f)

#define DIL_DISP_LOC(disp_imm)   (DIL_DISP_IMM_START(disp_imm))
#define DIL_IMM_LOC(disp_imm)    (DIL_DISP_LOC(disp_imm)+DIL_DISP_LEN(disp_imm))
#define DIL_IMM2_LOC(disp_imm)   (DIL_IMM_LOC(disp_imm)+DIL_IMM_LEN(disp_imm))
#define DIL_LENGTH(disp_imm)     (DIL_IMM2_LOC(disp_imm)+DIL_IMM2_LEN(disp_imm)) // actually this should not be used (in release code, debug is of course ok) (thats an optimization to do for you who read this (he, he))

struct InstrCode // used when a specific length requested
{
 public:
byte m_cCode[MAX_INSTR_CODE_LENGTH];
  word m_wDispImmLocs; // the length is actually stored here too, but inefficiently
  byte m_bLengthenTricksUsed;
};

struct InstrCodeLength
{
 public:
  byte m_cCode[MAX_INSTR_CODE_LENGTH];
  word m_wDispImmLocs; // the length is actually stored here too, but inefficiently
  byte m_bLength;
  byte m_bLengthenTricksUsed;
};

typedef vector<InstrCode> VectorInstrCode;
typedef vector<InstrCodeLength> VectorInstrCodeLength;

class InstructionEncoder  
{
 public:
  InstructionEncoder();
  virtual ~InstructionEncoder();
  
 public:
  bool	m_bCodeSize32;
  
 protected:
  static InverseOpcodeInfo* m_pInverseOpcodeInfo;
  static InverseOpcodeInfoIndex* m_pInverseOpcodeInfoIndex;
  static int m_nInverseOpcodeInfoIndex;
  
 public:
  static void InitInverseOpcodeInfo ();
  static InverseOpcodeInfo* FindFirstInverseOpcodeInfo (word nInstr);
  
 public:
  bool Encode (const Instruction* pInstr,
	       DataDestPtr& dataPtr,
	       word* pDispImmLocs = NULL
	       IFDEBUGPARAM(bool bUseFastEncoderIfPossible = false)
	       ) const; // return shortest possible length
  
#ifndef NDEBUG
  bool CheckFastEncoder (const Instruction* pInstr,
			 DataDestPtr& dataPtr,
			 word* pDispImmLocs,
			 const void* m_pStart) const;
#endif
  
  // and a routine to return all possible variants (or at least all
  // possible lengts)
  
  word EncodeLengths (const Instruction* pInstr/*,word* pDispImmLocs = NULL*/) const;
  
  bool Encode (const Instruction* pInstr,
	       DataDestPtr& dataPtr,
	       byte bLength,word* pDispImmLocs = NULL) const;
  
  bool Encode (const Instruction* pInstr,
	       VectorInstrCode& vectInstrCode,
	       byte bLength) const;
  
  bool Encode (const Instruction* pInstr,
	       VectorInstrCodeLength& vectInstrCodeLength) const;
  
 protected:
 /* FAST_ENCODER_STUFF:
  *
        bool FastStd2Op (const Instruction* pInstr,DataDestPtr& dataPtr) const;

        bool FastStd1Op (const Instruction* pInstr,DataDestPtr& dataPtr) const;
*/
/*
  bool TryEncoding (const InverseOpcodeInfo* inverseOpcodeInfo,
  const Instruction* pInstr,DataDestPtr& dataPtr) const;
*/
};

#endif // !defined(__INSTRUCTION_ENCODER_H__INCLUDED_)
