/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// MZFile.h: interface for the MZFile class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__M_Z_FILE_H__INCLUDED_)
#define __M_Z_FILE_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GlobalDefs.h" 

#ifdef WIN32
#pragma pack(push)
#pragma pack(2)
#endif

// The definitions for the file format were gotten from winnt.h of
// the wine project

#define IMAGE_MZ_SIGNATURE    0x5A4D     /* MZ   */

#define WORD word
#define DWORD dword

struct IMAGE_MZ_HEADER 
{
  WORD  e_magic;      /* 00: MZ Header signature */
  WORD  e_cblp;       /* 02: Bytes on last page of file */
  WORD  e_cp;         /* 04: Pages in file */
  WORD  e_crlc;       /* 06: Relocations */
  WORD  e_cparhdr;    /* 08: Size of header in paragraphs */
  WORD  e_minalloc;   /* 0a: Minimum extra paragraphs needed */
  WORD  e_maxalloc;   /* 0c: Maximum extra paragraphs needed */
  WORD  e_ss;         /* 0e: Initial (relative) SS value */
  WORD  e_sp;         /* 10: Initial SP value */
  WORD  e_csum;       /* 12: Checksum */
  WORD  e_ip;         /* 14: Initial IP value */
  WORD  e_cs;         /* 16: Initial (relative) CS value */
  WORD  e_lfarlc;     /* 18: File address of relocation table */
  WORD  e_ovno;       /* 1a: Overlay number */
  WORD  e_res[4];     /* 1c: Reserved words */
  WORD  e_oemid;      /* 24: OEM identifier (for e_oeminfo) */
  WORD  e_oeminfo;    /* 26: OEM information; e_oemid specific */
  WORD  e_res2[10];   /* 28: Reserved words */
  DWORD e_lfanew;     /* 3c: Offset to extended header */
};

#ifdef WIN32
#pragma pack(pop)
#endif

class MZFile  
{
 public:
  MZFile();
  virtual ~MZFile();
  
};

#endif // !defined(__M_Z_FILE_H__INCLUDED_)
