/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// OneOpInstr.h: interface for the OneOpInstr class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__ONE_OP_INSTR_H__INCLUDED_)
#define __ONE_OP_INSTR_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Instruction.h" // dep_chk_needed     

class OneOpInstr : public Instruction  
{
 public:
  OneOpInstr();
  virtual ~OneOpInstr();
  
 public:
  Operand* m_pOp;
  
 public:
  void SetDestOp (Operand* pOp) 
    { assert (!m_pOp || !pOp); if (pOp) { m_pOp = pOp; } }
  void SetSrcOp (Operand* pOp) 
    { assert (!m_pOp || !pOp); if (pOp) { m_pOp = pOp; } }
  
 public:
  virtual const Operand* GetDestOp () const 
    { return m_nInstruction != instrPUSH ? m_pOp : NULL; }
  virtual const Operand* GetSrcOp () const 
    { return m_nInstruction == instrPUSH ? m_pOp : NULL; }
  
 protected:
  virtual char* GenOpAsmString (char* pDest) const;
  
};

#endif // !defined(__ONE_OP_INSTR_H__INCLUDED_)
