/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// OperandImmediate.h: interface for the OperandImmediate class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__OPERAND_IMMEDIATE_H__INCLUDED_)
#define __OPERAND_IMMEDIATE_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Operand.h" 

class Variable;

class OperandImmediate : public Operand
{
 public:
  OperandImmediate();
  OperandImmediate(byte bImm);
  OperandImmediate(dword dwImm,byte	bImmBytes);
  OperandImmediate(dword dwImm,word	wImmHigh16,byte	bImmBytes);
  virtual ~OperandImmediate();
  
 public:
  dword	m_dwImm;
  word	m_wImmHigh16; // for far ptrs
  byte	m_bImmBytes;
  byte	m_bImmHigh16Bytes;
  
 public:
  virtual char* GenAsmString (char* pDest) const;
  
 public:
  //	virtual int ImmediateSize () { return m_bImmBytes; }
  virtual void SetImmediate (dword dwImm) { m_dwImm = dwImm; }
  virtual dword GetImmediate () const { return m_dwImm; }
  
  virtual word GetOpSize () const { return m_bImmBytes + m_bImmHigh16Bytes; }
  
 public:
  void SignExtend (int nDestSize);
  bool SignExtended() const;
  
 public:
  Variable* GetConstVar () const;
};

#endif // !defined(__OPERAND_IMMEDIATE_H__INCLUDED_)
