/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// PEFileSectionBody.cpp: implementation of the PEFileSectionBody class.
//
//////////////////////////////////////////////////////////////////////

#include "PEFileSectionBody.h" 
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

PEFileSectionBody::PEFileSectionBody()
{
  m_dwVirtualAddress = 0;
  m_nSizeOfRawData = 0;
  m_nSize = 0;
  
  m_pData = NULL;
}

PEFileSectionBody::~PEFileSectionBody()
{
  free (m_pData);
}

void PEFileSectionBody::SetSize (dword dwVirtualAddress,
				 dword nSize,dword nSizeOfRawData)
{
  assert (!m_pData);
  
  m_dwVirtualAddress = dwVirtualAddress;
  m_nSizeOfRawData = nSizeOfRawData;
  m_nSize = nSize;
}

bool PEFileSectionBody::Allocate (dword dwVirtualAddress,
				  dword nSize,dword nSizeOfRawData)
{
  assert (!m_pData);
  
  SetSize (dwVirtualAddress,nSize,nSizeOfRawData);
  
  if (!(m_pData = (byte*) malloc (nSizeOfRawData)))
    return false;
  
  memset (m_pData,0,nSizeOfRawData);
  
  return true;
}


