/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// PEFileSectionBody.h: interface for the PEFileSectionBody class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__P_E_FILE_SECTION_BODY_H__INCLUDED_)
#define __P_E_FILE_SECTION_BODY_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GlobalDefs.h" 

#define SECTION_MEM_EXECUTE	0x20000000

class PEFileSectionBody  
{
 public:
  PEFileSectionBody();
  virtual ~PEFileSectionBody();
  
 public:
  dword	m_dwVirtualAddress;
  dword	m_nSizeOfRawData;  // actual size of m_pData
  
  dword   m_dwCharacteristics;
  
  dword	m_dwFileOffset;
 private: // (because unused)
  dword	m_nSize;           // size of section in loaded image (unused, it seems)
  
 public:
  byte*	m_pData;
  
 public:
  bool Allocate (dword dwVirtualAddress,dword nSize,dword nSizeOfRawData);
  void SetSize (dword dwVirtualAddress,dword nSize,dword nSizeOfRawData);
  
 public:
  bool IsExecutable () 
    { return !!(m_dwCharacteristics & SECTION_MEM_EXECUTE); }
};

#endif // !defined(__P_E_FILE_SECTION_BODY_H__INCLUDED_)




