/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// RelocatableDest.h: interface for the RelocatableDest class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__RELOCATABLE_DEST_H__INCLUDED_)
#define __RELOCATABLE_DEST_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GlobalDefs.h" // dep_chk_needed     
#include "RelocationInfo.h" // dep_chk_needed     

class RelocatableDest  
{
 public:
  RelocatableDest();
  virtual ~RelocatableDest();
  
 public:
  byte* m_pData;
  dword m_dwSize;
  
  RelocationInfo m_relocInfo;
  
 public:
  void AllocDataBuffer(dword dwSize);
  byte* GetDataBuffer() { return m_pData; }
  
  dword AlignLength (dword dwAlign);
  
  dword GetData(void* pDest,dword dwOffset,dword dwLength) const;
  
 public:
  void AppendToEnd (word wRelocateSelf,
		    const RelocatableDest* pSrc,
		    dword& dwMoveFile,
		    dword& dwMoveImage,
		    dword dwAlign);
  
  
 public:
  dword Relocate(word wRelocate,dword dwMoveTo);
  void DoRelocate(word wRelocate,const MapDoRelocation& mapDoRelocation);
  
};

#endif // !defined(__RELOCATABLE_DEST_H__INCLUDED_)
