/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// RelocationInfo.cpp: implementation of the RelocationInfo class.
//
//////////////////////////////////////////////////////////////////////

#include "RelocationInfo.h" // dep_chk_needed 

#include <algorithm>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

RelocationInfo::RelocationInfo()
{
  m_dwFileOffset = 0;
  m_dwImageOffset = 0;


}

RelocationInfo::~RelocationInfo()
{

}

//	VectRelocInfo m_vectRelocInfo;

void RelocationInfo::InsertRelocation(dword dwOffset,word wRelocate) // insert anywhere (usable if writing the image in random order)
{
  RelocInfo info(wRelocate);
  
  // make sure that when inserted to offset does not interfere with another offset
#ifndef NDEBUG
  if (!m_mapOffsetRelocInfo.empty())
    {
      MapOffsetRelocInfo::iterator insertat = 
	m_mapOffsetRelocInfo.lower_bound(dwOffset);
      
      if (insertat != m_mapOffsetRelocInfo.end())
	{
	  dword dwAfter = insertat->first;
	  assert (dwAfter >= dwOffset+sizeof (dword));
	}
      
      if (insertat != m_mapOffsetRelocInfo.begin())
	{
	  dword dwBefore = (--insertat)->first;
	  assert (dwBefore+sizeof (dword) <= dwOffset);
	}
    }
#endif
  
  m_mapOffsetRelocInfo.insert(MapOffsetRelocInfo::value_type(dwOffset,info));
}






