/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// RelocationSection.cpp: implementation of the RelocationSection class.
//
//////////////////////////////////////////////////////////////////////

#include "RelocationSection.h"

#include "RelocatableDest.h"
#include "DataDestRelocPtr.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

RelocationSection::RelocationSection()
{

}

RelocationSection::~RelocationSection()
{

}

void RelocationSection::AddRelocations(RelocatableDest* pRelocate)
{
  dword dwChunkBase = 0;
  uint nNumRelocs = 0;
  
  FOR_EACH_ITER(MapOffsetRelocInfo,
		pRelocate->m_relocInfo.m_mapOffsetRelocInfo,reloc)
    {
      assert (reloc->first >= dwChunkBase); // give the relocations to us in order!
      
      if (reloc->first >= dwChunkBase + 0x1000)
        {
          // we need a new chunk
	  
          AssureDestMemory(sizeof (dword) + 0x1000 * sizeof (word)); // size of a maximally filled relocation buffer
          
          if (nNumRelocs & 0x01/* && align chunks to 32 bit boundary */)
            m_pDest->WriteWord(0);
          
          dwChunkBase = reloc->first;
          
          m_pDest->WriteDWord(dwChunkBase);
        }
      assert (reloc->first - dwChunkBase < 0x1000);
      m_pDest->WriteWord(0x3000 | (reloc->first - dwChunkBase));
      nNumRelocs++;
    }
}



