/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// ReportDisAsmInfo.cpp: implementation of the ReportDisAsmInfo class.
//
//////////////////////////////////////////////////////////////////////

#include "ReportDisAsmInfo.h" 
class BranchTarget; 
class CallFunction; 

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ReportDisAsmInfo::ReportDisAsmInfo(const MapCodeTraceCallFunction* pMapCodeTraceCallFunction)
{
  m_pMapCodeTraceCallFunction = pMapCodeTraceCallFunction;
  m_pUrlHtmlJavaViewer = NULL;
  m_pAnalyseFunction = NULL;
}

ReportDisAsmInfo::~ReportDisAsmInfo()
{
  
}

void ReportDisAsmInfo::AddFunctionUrlFile(const CallFunction* pFunction,
					  UrlFile* pFile,
					  int nType)
{
  assert (nType >= 0 &&
	  nType <= DIS_ASM_NUM_URLS);
  assert (pFile);
  
  MapCallFunctionUrlFiles::iterator iter = 
    m_mapCallFunctionUrlFiles.find(pFunction);
  
  if (iter != m_mapCallFunctionUrlFiles.end())
    {
      assert (!iter->second.m_pFile[nType]);
      
      iter->second.m_pFile[nType] = pFile;
    }
  
  ReportDisAsmFunctionUrls urls;
  
  urls.m_pFile[nType] = pFile;
  
  m_mapCallFunctionUrlFiles.insert(MapCallFunctionUrlFiles::value_type(pFunction,urls));
}

UrlFile* ReportDisAsmInfo::GetFunctionUrlFile(const CallFunction* pFunction,
					      int nType) const
{
  MapCallFunctionUrlFiles::const_iterator iter = 
    m_mapCallFunctionUrlFiles.find(pFunction);
  
  if (iter == m_mapCallFunctionUrlFiles.end())
    return NULL;
  
  return iter->second.m_pFile[nType];
}

CallFunction* ReportDisAsmInfo::GetTraceFunction (const BranchTarget* pTrace) const
{
  MapCodeTraceCallFunction::const_iterator func = 
    m_pMapCodeTraceCallFunction->find(pTrace);
  
  assert (func != m_pMapCodeTraceCallFunction->end());
  
  return func->second;
}

/*
void ReportDisAsmInfo::AddBranchingFunction(BranchTargetCtrlTransfer* pBranching,CallFunction* pFunction)
{
	assert (m_mapBranchingInFunction.find(pBranching) == m_mapBranchingInFunction.end());
	
	m_mapBranchingInFunction.insert(MapBranchingInFunction::value_type(pBranching,pFunction));
}

UrlFile* ReportDisAsmInfo::GetBranchingUrlFile(BranchTargetCtrlTransfer* pBranching,int nType) const
{
	MapBranchingInFunction::const_iterator iter = m_mapBranchingInFunction.find(pBranching);

	if (iter == m_mapBranchingInFunction.end())
		return NULL;

	CallFunction* pFunction = iter->second;

	return GetFunctionUrlFile(pFunction,nType);
}
*/
/*
string ReportDisAsmInfo::hrefToJavaView(UrlFile* pFileLinkSrc,UrlFile* pFileTargetJava)
{
	assert (m_pUrlHtmlJavaViewer);
	assert (pFileLinkSrc);
	assert (pFileTargetJava);
	
	return pFileLinkSrc->GetRelativePathToItem (m_pUrlHtmlJavaViewer) +
		"?file=" + m_pUrlHtmlJavaViewer->GetRelativePathToItem (pFileTargetJava);
}
*/

