/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// ReportDisAsmInfo.h: interface for the ReportDisAsmInfo class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__REPORT_DIS_ASM_INFO_H__INCLUDED_)
#define __REPORT_DIS_ASM_INFO_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GlobalDefs.h"

class UrlFile; 
#include <map>
#include <vector>

using namespace std;

#define DIS_ASM_URL_HTML	0
#define DIS_ASM_URL_JAVA	(DIS_ASM_URL_HTML+1)
#define DIS_ASM_NUM_URLS	(DIS_ASM_URL_JAVA+1)

class ReportDisAsmFunctionUrls
{
 public:
  ReportDisAsmFunctionUrls() { memset(m_pFile,0,sizeof(m_pFile)); }
  
 public:
  UrlFile* m_pFile[DIS_ASM_NUM_URLS];
};

class BranchTarget;
class CallFunction;
class BranchTarget;

typedef vector<BranchTarget*> VectCodeTraces;

typedef map<const CallFunction*,ReportDisAsmFunctionUrls> MapCallFunctionUrlFiles;
//typedef map<BranchTargetCtrlTransfer*,CallFunction*> MapBranchingInFunction;

typedef map<const BranchTarget*,CallFunction*> MapCodeTraceCallFunction;

class DataAnalyseFunction;

class ReportDisAsmInfo  
{
 public:
  ReportDisAsmInfo(const MapCodeTraceCallFunction* pMapCodeTraceCallFunction);
  virtual ~ReportDisAsmInfo();
  
 public:
  MapCallFunctionUrlFiles m_mapCallFunctionUrlFiles;
  //	MapBranchingInFunction m_mapBranchingInFunction;
  UrlFile* m_pUrlHtmlJavaViewer;
  
  const MapCodeTraceCallFunction* m_pMapCodeTraceCallFunction;
  
  const DataAnalyseFunction* m_pAnalyseFunction;
  
 public:
  void SetAnalyseFunction(const DataAnalyseFunction* pAnalyseFunction) 
    { m_pAnalyseFunction = pAnalyseFunction; }
  
 public:
  void AddFunctionUrlFile(const CallFunction* pFunction,
			  UrlFile* pFile,int nType);
  UrlFile* GetFunctionUrlFile(const CallFunction* pFunction,int nType) const;
  /*
    void AddBranchingFunction(BranchTargetCtrlTransfer* pBranching,CallFunction* pFunction);
    UrlFile* GetBranchingUrlFile(BranchTargetCtrlTransfer* pBranching,int nType) const;
  */
 public:
  CallFunction* GetTraceFunction (const BranchTarget* pTrace) const;
  
  
  /*
    public:
    string hrefToJavaView(UrlFile* pFileLinkSrc,UrlFile* pFileTargetJava);
  */
//	const MapBranchTargetVA* pMapBT_VA
  
 public:
  virtual string GetLabel (const BranchTarget* pTarget) const = 0;
  virtual bool GetOffset (const BranchTarget* /* pTarget */,
			  dword& /* dwOffset */) const 
    { return false; }
  
 public:
  virtual void SortCodeTraces(VectCodeTraces& vectCodeTraces) const = 0;
  
};

#endif // !defined(__REPORT_DIS_ASM_INFO_H__INCLUDED_)
