/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// ReportDisAsmInfoOffset.h: interface for the ReportDisAsmInfoOffset class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__REPORT_DIS_ASM_INFO_OFFSET_H__INCLUDED_)
#define __REPORT_DIS_ASM_INFO_OFFSET_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
using namespace std;

#include "ReportDisAsmInfo.h" 
#include "BranchTarget.h" 

class ReportDisAsmInfoOffset : public ReportDisAsmInfo  
{
 public:
  ReportDisAsmInfoOffset(const MapCodeTraceCallFunction* pMapCodeTraceCallFunction,const MapBranchTargetVA* pMapBranchTargetVA);
  virtual ~ReportDisAsmInfoOffset();
  
 protected:
  const MapBranchTargetVA* m_pMapBranchTargetVA;

 public:
  virtual string GetLabel (const BranchTarget* pTarget) const;
  virtual bool GetOffset (const BranchTarget* pTarget,dword& dwOffset) const;
  
 public:
  virtual void SortCodeTraces(VectCodeTraces& vectCodeTraces) const;
  
  
};

#endif // !defined(__REPORT_DIS_ASM_INFO_OFFSET_H__INCLUDED_)
