/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// TwoOpInstr.cpp: implementation of the TwoOpInstr class.
//
//////////////////////////////////////////////////////////////////////

#include "TwoOpInstr.h" 
#include "Operand.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TwoOpInstr::TwoOpInstr ()
{
  m_pDestOp = NULL;
  m_pSrcOp = NULL;
}

TwoOpInstr::~TwoOpInstr ()
{
  delete m_pDestOp;
  delete m_pSrcOp;
}

char *
TwoOpInstr::GenOpAsmString (char *pDest) const
{
  pDest = Instruction::GenOpAsmString (pDest);
  
  if (m_pDestOp)
    {
      pDest = m_pDestOp->GenAsmString (pDest);
    }
  if (m_pSrcOp)
    {
      if (m_pDestOp)
        *(pDest++) = ',';
      pDest = m_pSrcOp->GenAsmString (pDest);
    }
  return pDest;
}




