/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// TwoOpInstr.h: interface for the TwoOpInstr class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__TWO_OP_INSTR_H__INCLUDED_)
#define __TWO_OP_INSTR_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Instruction.h" 

class TwoOpInstr : public Instruction  
{
 public:
  TwoOpInstr();
  virtual ~TwoOpInstr();
  
 public:
  Operand* m_pDestOp;
  Operand* m_pSrcOp;
  
 public:
  void SetDestOp (Operand* pOp) { assert (!m_pDestOp);  m_pDestOp = pOp; }
  void SetSrcOp (Operand* pOp) { assert (!m_pSrcOp);  m_pSrcOp = pOp; }
  
 public:
  virtual const Operand* GetDestOp () const { return m_pDestOp; }
  virtual const Operand* GetSrcOp () const { return m_pSrcOp; }
  
 protected:
  virtual char* GenOpAsmString (char* pDest) const;
  
};

#endif // !defined(__TWO_OP_INSTR_H__INCLUDED_)
