/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// VarContStackPtr.h: interface for the VarContStackPtr class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__VAR_CONT_STACK_PTR_H__INCLUDED_)
#define __VAR_CONT_STACK_PTR_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "VarContent.h" 

class RegisterState;   

class VarContStackPtr : public VarContent
{
 public:	
  VarContStackPtr();
  VarContStackPtr(RegisterState* pState,dword dwOffset = 0);
  VarContStackPtr(VarContStackPtr const& src,dword dwAdd);
 public:
  virtual ~VarContStackPtr();
  
 public:
  // pState is the parent stack state (currently a part of
  // RegisterState) that defines the zero level of the stack. Zero
  // level would usually be the level which point to the return
  // address of a function
  
  RegisterState* m_pState;

  // offset is the offset of the current pointer from the zero level
  // of the stack. So the object of this that represents eSP will move
  // up and down but a pointer calculated to point at the return
  // address would hold 0, and a pointer to the first argument would
  // hold 4 (or 2, if 16-bit, which we do not support yet very much
  // (or more to the point, it is supported as far as this program is
  // tried be be generally written, but not otherwise))

  dword m_dwOffset;
  
  
  //public:
  //virtual string ValueString() const { return "VARCONTENT(error?)"; }

 public:
  virtual string ContentString() const;
  
};

#endif // !defined(__VAR_CONTENT_H__INCLUDED_)
