/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// Variable.h: interface for the Variable class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__VARIABLE_H__INCLUDED_)
#define __VARIABLE_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GlobalDefs.h" // dep_chk_unknown     
#include <vector>
#include <algorithm>
#include <string>

#include <assert.h>

#include "VarContent.h"

// // #include "DataState.h" // dep_chk_unknown     

using namespace std;

class Variable;

typedef vector<Variable*> VectVariable;

class Variable  
{
 protected:	
  Variable();
 public:
  virtual ~Variable();
  //	Variable(const Variable& src)
  Variable(const Variable& /* src */,bool bDep) 
    { assert (!bDep); m_pSource = NULL; m_pVarContent = NULL; }
  Variable(VarContent* pVarContent);
  
 public:
  // pSource and m_vectVarDepend keep track of interdependence
  // m_vectVarDepend is a list of other variables (obviously), but
  // pSource could be another variable, or a class telling us that the
  // information came out from an instruction (e.g. immediate)
  
  Variable* m_pSource;					
  VectVariable m_vectVarDepend;

 public:
  VarContent* m_pVarContent;
  
 public:
  void SetSource (Variable* pSrc) 
    { assert (!m_pSource); m_pSource = pSrc; }
  void AddDepend (Variable* pDep);
  void SetContent (VarContent* pVarContent) 
    { assert (!m_pVarContent); m_pVarContent = pVarContent; }
  
 public:
  virtual dword GetSize() = 0;
  
 public:
  virtual string ValueString() const { return "VAR(error?)"; }
  
};

#endif // !defined(__VARIABLE_H__INCLUDED_)
