/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// VariableNConst.cpp: implementation of the Variable class.
//
//////////////////////////////////////////////////////////////////////

#include "VariableNConst.h" 
#include "VariableNRange.h" 

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Variable* VariableNZero(int nBytes)
{
  if (nBytes == 1)
    return new Variable8Const(0);
  else if (nBytes == 2)
    return new Variable16Const(0);
  else
    {
      assert (nBytes == 4);
      return new Variable32Const(0);
    }
}

Variable* VariableNNonZero(int nBytes)
{
  if (nBytes == 1)
    return new Variable8Range(1,ALL_ONES(byte));
  else if (nBytes == 2)
    return new Variable16Const(1,ALL_ONES(word));
  else
    {
      assert (nBytes == 4);
      return new Variable32Const(1,ALL_ONES(dword));
    }
}

Variable* VariableN_Unknown(int nBytes)
{
  if (nBytes == 1)
    return new Variable8Unknown();
  else if (nBytes == 2)
    return new Variable16Unknown();
  else
    {
      assert (nBytes == 4);
      return new Variable32Unknown();
    }
}

