/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// VariableOp_CalcResult.h: interface for the VariableOp_CalcResult class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__VARIABLE_OP__CALC_RESULT_H__INCLUDED_)
#define __VARIABLE_OP__CALC_RESULT_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GlobalDefs.h" // dep_chk_needed     


template<class unsignedT>
struct calc_result_with_flags_type_info { };

#define CALC_RESULT_AND_FLAGS_TYPE_INFO(type) \
template<> \
struct calc_result_with_flags_type_info<type> \
{ \
  typedef void (*BinaryCalcResultWithFlagsFnc)(const type*,const type*,type*,word*); \
  typedef void (*UnaryCalcResultWithFlagsFnc)(const type*,type*,word*); \
  static const BinaryCalcResultWithFlagsFnc CalcResultWithFlags_add; \
  static const BinaryCalcResultWithFlagsFnc CalcResultWithFlags_sub; \
  static const BinaryCalcResultWithFlagsFnc CalcResultWithFlags_and; \
  static const BinaryCalcResultWithFlagsFnc CalcResultWithFlags_or; \
  static const BinaryCalcResultWithFlagsFnc CalcResultWithFlags_xor; \
  static const UnaryCalcResultWithFlagsFnc CalcResultWithFlags_neg; \
  static const UnaryCalcResultWithFlagsFnc CalcResultWithFlags_inc; \
  static const UnaryCalcResultWithFlagsFnc CalcResultWithFlags_dec; \
}; 

CALC_RESULT_AND_FLAGS_TYPE_INFO(byte)
     CALC_RESULT_AND_FLAGS_TYPE_INFO(word)
     CALC_RESULT_AND_FLAGS_TYPE_INFO(dword)

     /*
template<typename unsignedT>
void PerformAdd (const unsignedT* lhs,
				 const unsignedT* rhs,
				 unsignedT* result,
				 word* flags) 
{ 
	calc_result_and_flags_type_info<unsignedT>::CalcResultWithFlags_add(lhs,rhs,result,flags);

	
	
}
*/

#endif // !defined(__VARIABLE_OP__CALC_RESULT_H__INCLUDED_)
