#!/usr/bin/perl

#  exmhcg - executable program tuner  
#  Copyright (C) 2003  Hkan Johansson
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

$infile = $ARGV[0];
$outfile = $ARGV[1];
$starttag = $ARGV[2];

print "Generating $outfile, $outfile2 from $infile\n";

open(INFILE,"<$infile") || die "Can't open $infile";
open(OUTFILE,">$outfile") || die "Can't open $outfile";

print OUTFILE <<"EndOfText";
// $outfile: Copies of slightly altered functions from $infile 
//
//////////////////////////////////////////////////////////////////////
//
// This file is automatically generated by a script.
// Do not edit - useless.
//
//////////////////////////////////////////////////////////////////////

EndOfText

$doreplace = 0;

while ($readline = <INFILE>)
{ 
    if ($readline =~ /\/\*\s*$starttag\s+(.+)/)
    {
        $args = $1;
        while (!($args =~ /\*\//))
        {
            $add = <INFILE>;
            $add =~ s/^\s+/ /;
            $args .= $add;
        }
        $args =~ s/\*\/.*\s*//;
        $args =~ s/\n//g;
        $args =~ s/\r//g;
        # print "ARGS: $args\n";

        eval $args;

        print OUTFILE "//////////////////////////////////////////////////////////////////////\n";
        print OUTFILE "// $args\n";
        print OUTFILE "// \n";

        # print join(',',@replace);

        $doreplace = 1;
        @lines = ();
    }
    elsif ($readline =~ /\/\*\s*END_$starttag\s*\*\//)
    {
        $doreplace = 0;

        # perform replacements...

        while ($lines[0] =~ /^\s*$/) { shift @lines; }
        while ($lines[$#lines] =~ /^\s*$/) { pop @lines; }

        foreach $line (@lines)
        {
            print OUTFILE "// $line";
        }
        print OUTFILE "\n";

        foreach $repl (@replace)
        {
            # print "REPLACE: $repl\n";
            %repl = %$repl;

            # print OUTFILE "// ".join(',',%repl)."\n";

            foreach $line (@lines)
            {
                $replline = $line;
                foreach $key (keys %repl)
                {
                    if ($replline =~ /$repl{$key}/)
                    {
                        # we need to deal with possible swapping

                        $replline =~ s/$repl{$key}/_-_PLACEHOLDER_WHILE_SWAPPING_-_/g;
                        $replline =~ s/$key/$repl{$key}/g;
                        $replline =~ s/_-_PLACEHOLDER_WHILE_SWAPPING_-_/$key/g;
                    }
                    else
                    {
                        $replline =~ s/$key/$repl{$key}/g;
                    }

                    # print "$key  $repl{$key}\n";

                }		
                print OUTFILE $replline;
            }
            print OUTFILE "\n";
        }
    }
    elsif ($doreplace)
    {
        push @lines,$readline;
    }
}

close(INFILE);

print OUTFILE <<"EndOfText";

//////////////////////////////////////////////////////////////////////
EndOfText

close(OUTFILE);

