#!/usr/bin/perl

#  exmhcg - executable program tuner  
#  Copyright (C) 2003  Hkan Johansson
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

$infile = $ARGV[0];
$outfile = $ARGV[1];
$outfileinfo = $ARGV[2];

#$searchfor = $ARGV[2];
#$counter = $ARGV[3];
#$divide = $ARGV[4];

if (!defined($divide))
{ $divide = 1; }

# print "Generating $outfile from $infile\n\n";

@infiles = split /,/,$infile;

%op_on_types = ();
%ops = ();
@generate = ();
%gen_types = ();
%convert = ();
%argprio = ();

foreach $infile (@infiles)
{
    $generatefromfile = 1;
    if ($infile =~ /^inc@/)
    {
        $generatefromfile = 0;
        $infile =~ s/^inc@//;
    }
    # print $generatefromfile."-".$infile."\n";
    open(INFILE,"<$infile") || die "Can't open $infile";

while (<INFILE>)
{ 
    $readline = $_;

    if ($readline =~ /^\s*\/\/\s*argprio\((.+)\)=(\d+)/)
    {
        $argprio{$1} = $2;
    }
    elsif ($readline =~ /^\s*\#define\s+(VAR_INT_(.+)_OP)\(.+\)/)
    {
        $op_on_types_name = $1;
        
        # read until we've got two parenthesis
        $def = ();
        while (!(($def .= <INFILE>) =~ /\(.*\)/)) { $def =~ s/\\?\r?\n/ /g; } 
        $def =~ /\((.*)\)/;
        $args = $1;

        $args =~ s/\/\*//g;
        $args =~ s/\*\///g;

        @args = split /,/,$args;
        foreach $arg (@args) { $arg =~ s/^\s+//g; $arg =~ s/\s+([_a-zA-Z][_a-zA-Z0-9]*)\s*$//g; }

        # print "$op_on_types_name | ".join(',',@args)."\n";
        
        $op_on_types{$op_on_types_name} = join(',',@args);
    }
    elsif ($readline =~ /^template<class\s.*>\s$/)
    {
        # read until we've got two parenthesis
        $def = ();
        while (!(($def .= <INFILE>) =~ /\(.*\)/)) { $def =~ s/\\?\r?\n/ /g; } 
        $def =~ /(.*)\s(.*?)\((.*)\)/;
        $ret = $1;
        $op = $2;
        $args = $3;

        $args =~ s/\/\*//g;
        $args =~ s/\*\///g;

        @args = split /,/,$args;
        foreach $arg (@args) { $arg =~ s/^\s+//g; $arg =~ s/\s+([_a-zA-Z][_a-zA-Z0-9]*)\s*$//g; }

        if ($op =~ /Convert(.*)To/)
        {
            $args = $args[0];
            # print "$args -> $ret ($op)\n";

            $convertfrom{$op} = $args;
            $convertto{$op} = $ret;
        }
        # else
        {
            # print "$op | ".join(',',@args)."\n";

            $opname = $op;
            
            $types = join('|',@args);
            
            if ($oldtypes = $ops{$op})
            {
                $types = $oldtypes.",".$types;
            }
            
            # print "$op as $types\n";
            
            $ops{$op} = $types;
        }
        # $op_on_types{$op_on_types_name} = join(',',@args);
    }
    elsif ($readline =~ /^\s*(VAR_INT_.+_OP)\((.+)\)/)
    {
        $op = $2;
        $types = $1;

        if ($op =~ /(.+?),/)
        {
            $op = $1;
        } 

        if ($oldtypes = $ops{$op})
        {
            $types = $oldtypes.",".$types;
        }

        # print "$op as $types\n";

        $ops{$op} = $types;
    }
    elsif ($readline =~ /^\s*(GENERATE_VAR_.*?\(.*?\))\s*(\/\/)?\s*(.*?)\s*$/)
    {
        $gen = $1;
        $info = $3;
        $gen =~ s/\r/ /g; 
        $gen =~ s/\n/ /g; 

        if ($generatefromfile)
        {
            push @generate,$gen;
            
            $infos{$gen} = $info;
        }	
    }
    elsif ($readline =~ /^\s*\#define\s+(GENERATE_VAR_.*?)\(.*?\)\s*(\/\/)?\s*(.*?)\s*$/)
    {
        print ">> $1 | $2\n";
        $name = $1;
        $info = $3;

        if ($info =~ /rettype\=([^=]+)(\s|$)/) { $gen_rettype{$name}  = $1; }
        if ($info =~ /argtype\=([^=]+)(\s|$)/) { $gen_argtypes{$name}  = $1; }
        if ($info =~ /extraargs\=([^=]+)(\s|$)/) { $gen_extraargs{$name}  = $1; }
        if ($info =~ /invops\=([^=]+)(\s|$)/) { $gen_invops{$name}  = $1; }
        if ($info =~ /defret\=([^=]+)(\s|$)/) { $gen_defret{$name}  = $1; }
        if ($info =~ /mayconvert\=([^=]+)(\s|$)/) { $gen_mayconvert{$name}  = $1; }
        if ($info =~ /funcnameprefix\=([^=]+)(\s|$)/) { $gen_funcnameprefix{$name}  = $1; }
#	if ($info =~ /numtypedargs\=([^=]+)(\s|$)/) { $gen_numtypedargs{$name}  = $1; }

#define GENERATE_VAR_INT_BINARY_NOT_ORDERED_OP(name)     // type=(const VariableNConsts<unsignedT>*) 

	#$gen = $1;
	#$gen =~ s/\r/ /g; 
	#$gen =~ s/\n/ /g; 

	#push @generate,$gen;
    }
}

close(INFILE);
}
#define GENERATE_VAR_INT_BINARY_NOT_ORDERED_OP(name)     // type=(const VariableNConsts<unsignedT>*) 

#foreach $key (keys(%op_on_types))
#{
#    print $key.":".$op_on_types{$key}."\n";
#}
#
#foreach $key (keys(%ops))
#{
#    print $key.":".$ops{$key}."\n";
#}

#
#foreach $key (keys(%convertfrom))
#{
#    print $key." : ".$convertfrom{$key}." -> ".$convertto{$key}."\n";
#}

#VAR_INT_CONST_CONST_OP(Xor)
#VAR_INT_CONST_OP(Neg)
#GENERATE_VAR_INT_BINARY_NOT_ORDERED_OP(Add)

open(OUTFILE,">$outfile") || die "Can't open $outfile";
open(OUTFILEINFO,">$outfileinfo") || die "Can't open $outfileinfo";

print OUTFILE <<"EndOfText";
// $outfile: typed calls for Variable operations.
//
//////////////////////////////////////////////////////////////////////
//
// This file is automatically generated by a script.
// Do not edit - useless.
//
//////////////////////////////////////////////////////////////////////

\#define IF_TYPE(type,arg,var) type var; if (var = dynamic_cast<type>(arg))

EndOfText

print OUTFILEINFO <<"EndOfText";
// $outfileinfo: Info about typed calls for Variable operations.
//
//////////////////////////////////////////////////////////////////////
//
// This file is automatically generated by a script.
// Do not edit - useless.
//
//////////////////////////////////////////////////////////////////////

EndOfText

#while (@groups)
#{
#	$group = shift @groups;
#    $cnt = shift @groups;
#	
#	print OUTFILE sprintf("#define %-20s %d\n",$group,$cnt/$divide);
#
#}

#print OUTFILE sprintf("\n#define %-20s %d\n","${prefix}NUM_GROUPS",$count/$divide);

foreach $gen (@generate)
{
    #print OUTFILE $gen."\n";
    # print $gen."\n";

    foreach $gencmd (keys(%gen_argtypes))
    {
        # print $gencmd." ".$gen."\n";
         
        if ($gen =~ /$gencmd\s*\(\s*(.+?)\s*\)/)   
        {
            GenerateVarOp($gencmd,$1,$infos{$gen}); 
        }
    }

}

print OUTFILE <<"EndOfText";

//////////////////////////////////////////////////////////////////////
EndOfText
print OUTFILEINFO <<"EndOfText";

//////////////////////////////////////////////////////////////////////
EndOfText

close(OUTFILE);
close(OUTFILEINFO);

######################################################################

sub comparearguments
{
    @a = split /,/,$a;
    @b = split /,/,$b;

    while (@a && @b)
    {
        $ca = shift @a;
        $cb = shift @b;

        $ca =~ s/^const\s//;
        $cb =~ s/^const\s//;

        $cmp = ($argprio{$ca} <=> $argprio{$cb});
        return $cmp if $cmp;
    }
    return 0;
}

######################################################################

sub GenerateVarOp {
    $gencmd = shift;
    $names = shift;
    $info = shift;
    
    # print "$gencmd  $names  $info\n";
    
    $rettype = $gen_rettype{$gencmd};
    $types = $gen_argtypes{$gencmd};
    $extraargs = $gen_extraargs{$gencmd};
    $mayinvops = $gen_invops{$gencmd};
    $defaultreturn = $gen_defret{$gencmd};
    $mayconvert = $gen_mayconvert{$gencmd};
    $funcnameprefix = $gen_funcnameprefix{$gencmd};
#    $numtypedargs = $gen_numtypedargs{$gencmd};
    
    if ($info =~ /defret\=([^=]+)(\s|$)/) { $defaultreturn  = $1; }
        
    @types = split /\s*,\s*/,$types;
    @names = split /\s*,\s*/,$names;
    @mayconvert = split /,/,$mayconvert;

    $defaultreturn =~ s/OPNAME/$names[0]/g;

    if (!$defaultreturn) { $defaultreturn = "return;"; }

    if ($gencmd =~ /binary/i && $#names < 1) { push @names,$names[$#names]; }
    while ($#types < $#names) { push @types,$types[$#types]; }

    # print "Operator [".join(',',@names)."] (by $gencmd) as [".join(',',@types)."] to [".$rettype."]\n";

    @alltypes = (@types,$rettype);
    $classes = ();

    foreach $type (@alltypes)
    {
        if ($type =~ /<(.*)>/)
        {
            @typeclasses = split /,/,$1;
            foreach $class (@typeclasses)
            {
                $classes{$class} = $class;
            }
        }
    }
    @classes = sort keys %classes;

    if ($#classes >= 0)
    { $template = "template<class ".join(', class',@classes).">"; }
    else { $template = (); }

    @args = ();
    $argno = 1;
    foreach $type (@types)
    {
        push @args,"$type arg".$argno++;
    }

    $funcname = "$funcnameprefix$names[0]";

    @extraargs = split /,/,$extraargs;
    @extraparams = ();
    @extratypes = ();
    foreach $extra (@extraargs)
    {
        $extra =~ /^(.*)\s(.*?)$/;
        $extratype = $1;
        $param = $2;
        # print "Extra: $extra ($param)\n";
        push @extratypes,$extratype;
        push @extraparams,$param;
    }
    $extraparams = join(',',@extraparams);
    if ($extraparams) { $extraparams = ','.$extraparams; }
    # print "Extra: $extraparams\n";
    
    @allargs = (@args,@extraargs);

    $callsequence = "$rettype $funcname(";
    $indent = $callsequence; $indent =~ s/./ /g;
    $callsequence .= join(",\n".$indent,@allargs).")";

    print OUTFILE "//////////////////////////////////////////////////////////////////////\n";
    print OUTFILE "// Operator \'$names[0]\'\n";
    print OUTFILE "\n";
    print OUTFILE "$template\n";
    print OUTFILE "$callsequence\n";
    print OUTFILE "{\n";
    
    $perlsimfunc = "sub $funcname {\n";
    $perlsimfunc .= "    my \$depth = shift;\n    if (\$depth > 5) { return '** Infinite recursion **'; }\n";
    $perlsimfunc .= "    my \@args = \@_;\n";
    for ($i = 1; $i <= $#types + 1; $i++)
    {
        $perlsimfunc .= "    my \$arg$i = shift;\n";
    }

    print OUTFILEINFO "//////////////////////////////////////////////////////////////////////\n";
    print OUTFILEINFO "// Operator \'$names[0]\'\n";
    print OUTFILEINFO "\n";
    
    %possargs = ();
        
    # now figure out what combinations of arguments we can handle
    # 

    if ($#names > 0 && $mayinvops)
    {
        @ops = split /,/,$ops{$names[1]};
        foreach $op (@ops)
        {
            @args = split /,/,(OpOnTypes($op));
            @args = KillUnneededConsts (\@args,\@types);
            $possargs{"$args[1],$args[0]"} = "swap_args_".$names[1];
        }
    }
    @ops = split /,/,$ops{$names[0]};
    foreach $op (@ops)
    {
        @args = split /,/,(OpOnTypes($op));
        @args = KillUnneededConsts (\@args,\@types);

        $kill = $#args;
      kill_extra_types_loop:
        for ($extra = $#extratypes; $extra >= 0 && $kill >= 0; $extra--, $kill--)
        {
            if (($args[$kill] eq $extratypes[$extra]) ||
                ("const ".$args[$kill] eq $extratypes[$extra]))
            {
                # print "$funcname : $args[$kill] >=< $extratypes[$extra] ($kill,$extra) ??\n";
                pop @args;
            }
            else { last kill_extra_types_loop; }
        }
        $possargs{join(',',@args)} = $names[0];
        
        # print join(',',@args)."\n";
    }
    foreach $opname (keys %ops)
    {
        if ($opname =~ /^Convert(.+)To(.+)$/)
        {
            $opchanged = $opname;
            $opchanged =~ s/^Convert(.+)To(.+)$/ConvertTo$2/;
            if ($opchanged eq $names[0])
            {
                @ops = split /,/,$ops{$opname};
                foreach $op (@ops)
                {
                    @args = split /,/,(OpOnTypes($op));
                    @args = KillUnneededConsts (\@args,\@types);
                    $possargs{join(',',@args)} = $opname;

                    # print "=> $opname , @args\n";
                }	
            }
        }
    }

    @possargs = sort comparearguments keys %possargs;

    # Now see if we can have any more possible arguments by invoking appropriate converters
    # before attempting the calculation

    %possconvargs = ();

    foreach $args (@possargs)
    {
        # print "$args $possargs{$args}\n";

        @args = split /,/,$args;

        $ii = 0;	
        foreach $arg (@args)
        {
            # print "mayconv: $ii : $mayconvert[$ii]\n";
            if (!$mayconvert || $mayconvert[$ii])
            {
                # do we have an converter to this arg?
                $cmparg = $arg;
                $cmparg =~ s/^const //;
                # print "$cmparg...\n";
                
                foreach $converter (keys(%convertto))
                {
                    # print "$convertto{$converter} !\n";
                    if ($convertto{$converter} eq $cmparg)
                    {
                        @arg = $convertfrom{$converter};
                        @type = $types[$ii];

                        @arg = KillUnneededConsts (\@arg,\@type);

                        # print join(',',@types)."\n";
                        # print "$types[$ii] | $ii : $cmparg <- $arg[0] via $converter\n";
                        
                        $arg = $arg . "|$cmparg&$arg[0]&$converter";
                        #$arg = $arg . "|$cmparg&$convertfrom{$converter}&$converter";
                    }
                }
            }
            $ii++;
        }
        # print join(' , ',@args)."\n";

        %allargscombs = GenerateAllCombs(@args);

        # now see if any combination is for something we do not already have

        foreach $argcomb (keys(%allargscombs))
        {
            if (!$possargs{$argcomb})
            {
                if ($possconvargs{$argcomb})
                {
                    # Multiple conversions are available
                    # Try to determine which is best

                    # 1st, as few conversions as possible

                    $conv_prev = $possconvargs{$argcomb};
                    $conv_this = $allargscombs{$argcomb};

                    $conv_prev =~ s/[^&]//g;
                    $conv_this =~ s/[^&]//g;

                    if ($conv_this lt $conv_prev) { goto use_this_conv; }
                    if ($conv_this gt $conv_prev) { goto use_prev_conv; }

                    # 2nd, if more than one arg, conversion to same arg type is preferred

                    $conv_prev = $possconvargs{$argcomb};
                    $conv_this = $allargscombs{$argcomb};
                    
                    $conv_prev =~ s/^const\s+//;
                    $conv_this =~ s/^const\s+//;
                    
                    $conv_prev =~ s/&.+?(,|$)//; 
                    $conv_this =~ s/&.+?(,|$)//;
                                             
                    $ndiffs_prev = NumArgTypeDiffs($conv_prev);
                    $ndiffs_this = NumArgTypeDiffs($conv_this);

                    if ($ndiffs_this < $ndiffs_prev) { goto use_this_conv; }
                    if ($ndiffs_this > $ndiffs_prev) { goto use_prev_conv; }

                    print "%%% $funcname:\n";
                    print "%%% Multiple conversions available: $argcomb\n";
                    print "%%% Using last one seen (might want to change this (to use best? one)??)\n";
                    print "%%% prev: $possconvargs{$argcomb}\n";
                    print "%%% this: $allargscombs{$argcomb}\n\n";
                    
                }

                # print "- $argcomb\n$allargscombs{$argcomb}\n\n";
              use_this_conv:
                $possconvargs{$argcomb} = $allargscombs{$argcomb};
              use_prev_conv:
            }
        }
    }

    # now see if all args to be converted are converted in the same way

    %convfromto = ();

    foreach $args (keys %possconvargs)
    {
        $convargs = $possconvargs{$args};

        @convargs = split /,/,$convargs;

        for ($i = 0; $i <= $#convargs; $i++)
        {
            if ($convargs[$i] =~ /(.*)&(.*)&(.*)/)
            {
                $to = $1."&".$3;
                $from = $2;
            }
            else
            {
                $to = $from = $convargs[$i];
            }
            $ifrom = "$i:$from";

            # print "$to <- $from\n";

            $old = $convfromto{$ifrom};

            if ($old && $old ne $to)
            {
                $convfromto{$ifrom} = "--multiple--";
            }
            else
            {
                $convfromto{$ifrom} = $to;
            }
        }
    }

    foreach $args (keys %possconvargs)
    {
        $convargs = $possconvargs{$args};

        @convargs = split /,/,$convargs;

        $conversions = "conv";

        for ($i = 0; $i <= $#convargs; $i++)
        {
            if ($convargs[$i] =~ /(.*)&(.*)&(.*)/)
            {
                $to = $1."&".$3;
                $from = $2;
            }
            else
            {
                $to = $from = $convargs[$i];
            }
            $ifrom = "$i:$from";

            # print "$to <- $from\n";

            $old = $convfromto{$ifrom};

            if ($convfromto{$ifrom} eq $to)
            {
                # we're simplified away
            }
            elsif ($to =~ /&/)
            {
                # print "conv_".$from."\n";
                $conversions .= "_$i:$to";
                $convargs[$i] = $from;
            }
        }
        if ($conversions ne "conv")
        {
            $possargs{join(',',@convargs)} = $conversions;
    	}
    }

    @possargs = sort comparearguments keys %possargs;

    # print "\n";

#    foreach $args (@possargs)
#    {
#    	print "$args <- $possargs{$args}\n";
#    }
#    foreach $args (keys %possconvargs)
#    {
#	print "$args <- $possconvargs{$args}\n";
#    }
#    foreach $ifrom (keys %convfromto)
#    {
#        print "$ifrom -> $convfromto{$ifrom}\n";
#    }

#    print "\n---------------------------------------------\n";

    $needgoto_try_conversion2 = 0;

  outerloop:
    for ($i = 0; $i <= $#possargs; )
    {
        $args = $possargs[$i];
        @args = split /,/,$args;
        if ($args[0] eq 'ANY_PARAMETER') { $i++; next outerloop; }
        if ($#args == 0)# || $numtypedargs == 1)
        {
	    $func_name = $possargs{$args[0]};

	    # print "HERE: $func_name $names[0]\n";

            print OUTFILE "    IF_TYPE($args,arg1,type$i)  return $func_name(type$i$extraparams);\n";
            # print OUTFILE "    IF_TYPE($args,arg1,type$i)  return $names[0](type$i$extraparams);\n";
            $perlsimfunc .= "    if(MatchCast(\$arg1,\"$args\")) { return(\@args,\"$names[0]\"); }\n";    
            $i++;
        }
        else
        {
            print OUTFILE "    IF_TYPE($args[0],arg1,type1_$i)\n    {\n";
            $perlsimfunc .= "    if(MatchCast(\$arg1,\"$args[0]\")) {\n";    
            $ii = $i;
          innerloop:
            for ($j = $i; $j <= $#possargs; $j++)
            {
                $args2 = $possargs[$j];
                @args2 = split /,/,$args2;
                
                if ($args2[0] ne $args[0])
                {
                    last innerloop;
                }
                if ($args2[1] eq 'ANY_PARAMETER') { $i++; next innerloop; }
                $func_name = $possargs{$args2};

                @localargs = ("type1_$ii","type2_$j");

                $precall = "return ";
                $postcall = ";";

                $perlsimfunccall = "\"$func_name\"";

                if ($func_name =~ /conv_(\d+):(.+)&(.+)_(\d+):(.+)&(.+)/) 
                { 
		    # print "\n\n*".$func_name."\n";

                    $convargno1 = $1;
                    $to1 = $2;
                    $converter1 = $3;
                    $convargno2 = $4;
                    $to2 = $5;
                    $converter2 = $6;

                    # PrintConversionCall($rettype,$convargno,"$to&$converter",$localargs[$convargno],"**");

                    $precall = "{ $to1 pConv$convargno1 = $converter1($localargs[$convargno1]); $to2 pConv$convargno2 = $converter2($localargs[$convargno2]); $rettype pRet = ";
                    $postcall = "; delete pConv$convargno1; delete pConv$convargno2; return pRet; }";	
                    $localargs[$convargno1] = "pConv$convargno1";
                    $localargs[$convargno2] = "pConv$convargno2";

                    @theseargs = @args2;
                    if ((@theseargs[$convargno1] =~ /^const /) &&
                        !($to1 =~ /^const / ))
                    {
                        $to1 = "const ".$to1;
                    }
                    if ((@theseargs[$convargno2] =~ /^const /) &&
                        !($to2 =~ /^const / ))
                    {
                        $to2 = "const ".$to2;
                    }
                    @theseargs[$convargno1] = $to1;
                    @theseargs[$convargno2] = $to2;
                    $theseargs = join(',',@theseargs);

		    $func_name = "$funcnameprefix$names[0]";

                    # $func_name = $possargs{$theseargs};

                    $perlsimfunccall = "\"->\",\"". join('","',@theseargs)    ."\",\"$func_name\"";
                }
                elsif ($func_name =~ /conv_(\d+):(.+)&(.+)/) 
                { 
                    $convargno = $1;
                    $to = $2;
                    $converter = $3;

                    # PrintConversionCall($rettype,$convargno,"$to&$converter",$localargs[$convargno],"**");

                    $precall = "{ $to pConv$convargno = $converter($localargs[$convargno]); $rettype pRet = ";
                    $postcall = "; delete pConv$convargno; return pRet; }";	
                    $localargs[$convargno] = "pConv$convargno";

                    @theseargs = @args2;
                    if ((@theseargs[$convargno] =~ /^const /) &&
                        !($to =~ /^const / ))
                    {
                        $to = "const ".$to;
                    }
                    @theseargs[$convargno] = $to;
                    $theseargs = join(',',@theseargs);

		    $func_name = "$funcnameprefix$names[0]";

                    # $func_name = $possargs{$theseargs};

                    $perlsimfunccall = "\"->\",\"". join('","',@theseargs)    ."\",\"$func_name\"";
                }

                {
                    if ($func_name =~ /swap_args_(.*)/) { $func_call = "$1($localargs[1],$localargs[0]$extraparams)"; }
                    else { $func_call = "$func_name($localargs[0],$localargs[1]$extraparams)"; }
                    
                    print OUTFILE "        IF_TYPE($args2[1],arg2,type2_$j)   $precall $func_call$postcall\n";
                    $perlsimfunc .= "        if(MatchCast(\$arg2,\"$args2[1]\")) { return (\@args,$perlsimfunccall); }\n";    
                }
                $i++;
            }   
            
            $ifrom = "0:".$args[0];
            
            if ($convfromto{$ifrom} =~ /&/)
            {
                print OUTFILE "\n";
                PrintConversionCall($rettype,$args[0],$convfromto{$ifrom},"type1_$ii","        ");
                $convfromto{$ifrom} = null;
            }
            else
            {
                print OUTFILE "        goto try_conversion2;\n";
                $perlsimfunc .= "        goto try_conversion2;\n";    
                $needgoto_try_conversion2 = 1;
            }
            print OUTFILE "    }\n";
            $perlsimfunc .= "    }\n";    
        }
    }

    # $op_on_types{$key}
    # $ops{$key}

    @convfromto = sort comparearguments keys %convfromto;

    $k = $#possargs+1;
    foreach $ifrom (@convfromto)
    {
        if ($ifrom =~ /^0:/) { $k = TestPrintConversionCall($rettype,$ifrom,$convfromto{$ifrom},$k,"    "); }
    }

    foreach $args (@possargs)
    {
        @args = split /,/,$args;
        if ($args[0] eq 'ANY_PARAMETER')
        {
            print OUTFILE "    // arg1 of type ANY_PARAMETER\n";
            print OUTFILE "    IF_TYPE($args[1],arg2,type1_$k)  return $names[0](type1_$k$extraparams);\n";
            $perlsimfunc .= "    if(MatchCast(\$arg2,\"$args[1]\"))  { return (\@args,\"$names[0]\"); }\n";    
            $k++;
            # OutFileInfo ($names[0],$args);
        }	
    }

    if ($needgoto_try_conversion2)
    {
        $some_anyparameter = 0;

        foreach $args (@possargs)
        {
            @args = split /,/,$args;
            if ($args[1] eq 'ANY_PARAMETER')
            {
                $some_anyparameter = 1;
            }	
        }

        if (!$some_anyparameter)
        {
            print OUTFILE "    $defaultreturn; // nothing more do to if arg1 doesn't fit\n";
            $perlsimfunc .= "    return (\@args,\"---\");\n";    
        }

        print OUTFILE "try_conversion2:\n";
        $perlsimfunc .= "try_conversion2:\n";    
        
        $k = $#possargs+1;
        foreach $ifrom (@convfromto)
        {
            if ($ifrom =~ /^1:/) { $k = TestPrintConversionCall($rettype,$ifrom,$convfromto{$ifrom},$k,"    "); }
        }
 
        foreach $args (@possargs)
        {
            @args = split /,/,$args;
            if ($args[1] eq 'ANY_PARAMETER')
            {
                print OUTFILE "    // arg2 of type ANY_PARAMETER\n";
                print OUTFILE "    IF_TYPE($args[0],arg1,type2_$k)  return $names[0](type2_$k$extraparams);\n";
                $perlsimfunc .= "    if(MatchCast(\$arg1,\"$args[0]\"))  { return (\@args,\"$names[0]\"); }\n";    
                $k++;
                # OutFileInfo ($names[0],$args);
            }	
        }

    }

    print OUTFILE "    $defaultreturn;\n}\n\n";

    $perlsimfunc .= "    return (\@args,\"---\");\n}\n";    
    # print OUTFILEINFO "$perlsimfunc";

    eval "$perlsimfunc;"; warn $@ if $@; 

    @allargs = sort comparearguments keys %argprio;

    foreach $arg1 (@allargs)
    {
        if ($#types == 0)
        {
            eval "OutFileInfo ($funcname(0,'$arg1'));"; warn $@ if $@;     
        }
        else
        {
            foreach $arg2 (@allargs)
            {
                eval "OutFileInfo ($funcname(0,'$arg1','$arg2'));"; warn $@ if $@; 
            }
        }
    }

    print OUTFILEINFO "\n";
}

######################################################################

sub OutFileInfo {
    @info = @_;

    foreach $info (@info)
    {
        $info =~ s/const //g;
        $info =~ s/VariableN//g;
        $info =~ s/<unsignedT>*//g;

        if ($info eq "->")
        {
            print OUTFILEINFO "$info ";	    
        }
        else
        {
            print OUTFILEINFO sprintf("%-15s ",$info);
        }
    }
    print OUTFILEINFO "\n";
}

######################################################################

sub OpOnTypes {
    my $op = shift;

    if ($op_on_types{$op})
    {
        return $op_on_types{$op};
    }

    $op =~ s/\|/,/g;

    return $op;
}

######################################################################

sub GenerateAllCombs {
    my @args = @_;

    my %allargscombs = ("","");
    my $sep = "";

    my $firstarg = shift @args;

    if ($#args >= 0)
    {
        %allargscombs = GenerateAllCombs(@args);
        $sep = ",";
    }

    my @firstargs = split /\|/,$firstarg;

    my %argcombs = ();

    foreach $farg (@firstargs)
    {
        foreach $largfrom (keys (%allargscombs))
        {
            $fargfrom = $farg;
            $fargfrom =~ s/^.*?&//;
            $fargfrom =~ s/&.*?$//;

            # print "-- $farg ($fargfrom)\n";

            $larg = $allargscombs{$largfrom};

            $from = "$fargfrom$sep$largfrom";
            $full = "$farg$sep$larg";

            $argcombs{$from} = $full;
        }
    }
    return %argcombs;
}

######################################################################

sub TestPrintConversionCall {
    my $rettype = shift;
    my $ifrom = shift;
    my $to = shift;
    my $k = shift;
    my $indent = shift;

    $ifrom =~ /(.+):(.+)/;
    my $i = $1;
    my $from = $2;
    my $argno = $i+1;
    
    if ($to =~ /(.+)&(.+)/)
    {

#    print "$ifrom -> $to\n";

	print OUTFILE "${indent}//    arg$argno -> $to ???\n";
	print OUTFILE "${indent}IF_TYPE($from,arg$argno,type$argno\_$k)   ";
	$perlsimfunc .= "${indent}if(MatchCast(\$arg$argno,\"$from\"))  ";    

        DoPrintConversionCall($rettype,$ifrom,$to,"type$argno\_$k");

        print OUTFILE "\n";
        $perlsimfunc .= "\n";    

        $k++;
    }
    return $k;
}

######################################################################

sub DoPrintConversionCall {
    my $rettype = shift;
    my $ifrom = shift;
    my $to = shift;
    my $convarg = shift;

    $ifrom =~ /(.+):(.+)/;
    my $i = $1;
    my $from = $2;
    my $argno = $i+1;
    
    if ($to =~ /(.+)&(.+)/)
    {
        my $funcname = $2;
        my $totype = $1;
        
        print OUTFILE "{ ";

        my $callsequence = "$funcnameprefix$names[0](";
        my $callsequenceperlsim = "$funcnameprefix$names[0](\$depth+1,";
        #my $callsequenceperlsim = "\&\$PerlSimFunc(";
        my @callargs = ();
        my @callargsperlsim = ();
        my @convobjs = ();
        for (my $callargno = 1; $callargno <= $#types+1; $callargno++)
        {
            if ($callargno == $argno) { print OUTFILE "$totype pConv$callargno = $funcname($convarg); "; push @callargs , "pConv$callargno"; push @convobjs,"pConv$callargno"; push @callargsperlsim , "\"$totype\""; }
            else { push @callargs , "arg".$callargno; push @callargsperlsim , "\$arg".$callargno; }
        }
        $callsequence .= join(',',@callargs);
        $callsequenceperlsim .= join(',',@callargsperlsim);
        $callsequence .= $extraparams.")";
        $callsequenceperlsim .= ")";
        
        print OUTFILE "$rettype pRet = $callsequence; delete @convobjs; return pRet; }";
        $perlsimfunc .= "{ return (\@args,\"->\",$callsequenceperlsim); }";    
        $k++;
    }
    return $k;
}

######################################################################

sub PrintConversionCall {
    my $rettype = shift;
    my $ifrom = shift;
    my $to = shift;
    my $convarg = shift;
    my $indent = shift;

    $ifrom =~ /(.+):(.+)/;
    my $i = $1;
    my $argno = $i+1;
    
    if ($to =~ /(.+)&(.+)/)
    {
        print OUTFILE "${indent}// $convarg -> $to\n${indent}";
        $perlsimfunc .= "${indent}";    

        DoPrintConversionCall($rettype,$ifrom,$to,$convarg);

        print OUTFILE "\n";
        $perlsimfunc .= "\n";    
    }
}

######################################################################

sub KillUnneededConsts {
    my $args_ref = shift;
    my $types_ref = shift;

    my @args = @$args_ref;
    my @types = @$types_ref;

    for ($i = 0; $i <= $#args; $i++)
    {
        if (!($types[$i] =~ /^const\s/))
        {
            $args[$i] =~ s/^const\s//;
        }
        
    }    
    return @args;
}

######################################################################

sub MatchCast {
    my $arg = shift;
    my $match = shift;

    if (!($arg =~ /^const\s*/)) { $match =~ s/^const\s*//; }

    return $arg eq $match;
}

######################################################################

sub NumArgTypeDiffs {
    my $args = shift;

    @args = split /,/,$args;

    $diffs = 0;

    for ($i = 1; $i <= $#args; $i++)
    {
        for ($j = 0; $j <= $i; $j++)
        {
            if ($args[$i] ne $args[$j])
            {
                $diffs++;
            }
        }	
    }
    # print $args."   ".$diffs."\n";
    return $diffs;
}

######################################################################




