/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// VariableSimplify.h: interface for the Variable class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__VARIABLE_SIMPLIFY_H__INCLUDED_)
#define __VARIABLE_SIMPLIFY_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "VariableN.h"

/*
template<class unsignedT>
VariableN<unsignedT>* VariableNSplit<unsignedT>::SimplifyVariable()
{



  if ((!m_low  || dynamic_cast<VariableNSplit<unsignedT>::half_var_type>(m_low) ) && 
      (!m_high || dynamic_cast<VariableNSplit<unsignedT>::half_var_type>(m_high))) // nothing is known
    return new VariableN<unsignedT>();



  return NULL;
}
*/

template<class unsignedT>
VariableN<unsignedT>* ReplaceIfNoDep(VariableN<unsignedT>*& pVar,
				     VariableN<unsignedT>* pVarNew)
{
  if (pVar->m_vectVarDepend.empty())
    {
      // there are no depends, so replace it

      pVarNew->m_pSource = pVar->m_pSource;
      
      delete pVar; // delete old one (no depends, and pVar is to be only ptr)
      
      pVar = pVarNew;
      return pVarNew;
    }
  pVar->AddDepend (pVarNew);
  return pVarNew;
}

template<class unsignedT>
VariableN<unsignedT>* SimplifyVariable(VariableN<unsignedT>*& pVar)
{
  VariableN<unsignedT> pNew = pVar->SimplifyVariable();

  if (!pNew) // could not be simplified
    return pVar; 
  
  // could be written in simpler way
  
  return ReplaceIfNoDep (pVar,pNew);
}

#endif // !defined(__VARIABLE_SIMPLIFY_H__INCLUDED_)
