/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// mapstack.h: mapstack
//
//////////////////////////////////////////////////////////////////////

#if !defined(__MAP_STACK_H__)
#define __MAP_STACK_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <map>
#include <stack>

using namespace std;

template<class __T,class __S>
class mapstack
{
 public:
  typedef map<__T,__S> map_type;
  typedef stack<__T> stack_type;

  typedef typename map_type::value_type map_value_type;
  typedef typename map_type::iterator map_iter;

 protected:
  stack_type m_stack;
  map_type m_map;

 public:
  map_type& get_map() { return m_map; }  
  
 public:
  bool empty() const
    { return (m_stack.empty()); }
  __T& top()
    { return (m_stack.top()); }
  void push(const __T& __X,const __S& __Y)
    { 
      map_iter iter = m_map.find(__X);
      if (iter == m_map.end())
        {
          m_map.insert(map_value_type(__X,__Y));
          m_stack.push(__X);
        }
      else
	{
	  iter->second.combine(__Y);
	}
    }
  map_value_type pop()
    {
      __T __X = m_stack.top();
      m_stack.pop();
      assert(m_map.find(__X) != m_map.end());
      map_value_type __R = *(m_map.find(__X));
      m_map.erase(__X);
      return __R;
    }
};

#endif // !defined(__MAP_STACK_H__)


