/*  exmhcg - executable program tuner  
 *  Copyright (C) 2003  Hkan Johansson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// setdeque.h: setdeque
//
//////////////////////////////////////////////////////////////////////

#if !defined(__SET_DEQUE_H__)
#define __SET_DEQUE_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <set>
#include <deque>

using namespace std;

template<class __T>
class setdeque
{
 public:
  typedef set<__T> set_type;
  typedef deque<__T> deque_type;
  
 protected:
  deque_type m_deque;
  set_type m_set;
  
 public:
  set_type& get_set() { return m_set; }  
  
 public:
  bool empty() const
    { return (m_deque.empty()); }
  __T& top()
    { return (m_deque.top()); }
  void push_front(const __T& __X)
    { 
      if (m_set.find(__X) == m_set.end())
        {
          m_set.insert(__X);
          m_deque.push_front(__X);
        }
    }
  void push_back(const __T& __X)
    { 
      if (m_set.find(__X) == m_set.end())
        {
          m_set.insert(__X);
          m_deque.push_back(__X);
        }
    }
  __T pop_front()
    {
      __T __X = m_deque.front();
      m_deque.pop_front();
      m_set.erase(__X);
      return __X;
    }
  __T pop_back()
    {
      __T __X = m_deque.back();
      m_deque.pop_back();
      m_set.erase(__X);
      return __X;
    }
};

#endif // !defined(__SET_DEQUE_H__)


